CNode : Object ( value type )
  CInteger : CNode ()	"value is Integer"
  CString  : CNode ()	"String"
  CList    : CNode ()	"SequenceableCollection"
  CSymbol  : CNode ()	"Symbol"


CNode value	[ ^value ]
CNode type	[ ^type ]

CNode withValue: anObject
[
    self := super new.
    value := anObject.
    type := CUnknownType.
]

CNode printOn: aStream
[
    self printOn: aStream indent: 0
]

CNode printOn: aStream indent: indent
[
    aStream space: indent.
    self printValueOn: aStream.
    aStream tab.
    self printTypeOn: aStream.
]

CNode printValueOn: aStream	[ value printOn: aStream ]
CNode printTypeOn: aStream	[ aStream nextPut: $<; print: type; nextPut: $> ]

"----------------------------------------------------------------"

CInteger readFrom: aStream base: radix
[
    ^self withValue: (Integer readFrom: aStream base: radix)
]

"----------------------------------------------------------------"

CNode isCSymbol		[ ^false ]
CSymbol isCSymbol	[ ^true ]

CSymbol printValueOn: aStream
[
    aStream nextPutAll: value
]

"----------------------------------------------------------------"

CNode isCList		[ ^false ]
CList isCList		[ ^true ]

CNode isCLambda		[ ^false ]
CList isCLambda		[ ^value size >= 2 and: [value first value == #lambda and: [value second isCList]] ]

CList new		[ ^self withValue: OrderedCollection new ]

CList add: anObject	[ ^value add: anObject ]

CList printOn: aStream indent: indent
[
    aStream space: indent; nextPut: $(; nl.
    value do: [:elt | elt printOn: aStream indent: indent + 2] separatedBy: [aStream nl].
    aStream nl; space: indent; nextPut: $); tab.
    self printTypeOn: aStream.
]

CList matchSymbol
[
    ^(value notEmpty and: [value first isCSymbol])
	ifTrue:  [value removeFirst]
	ifFalse: [self error: 'identifier expected']
]

CList matchSymbol: aSymbol
[
    ^(value notEmpty and: [value first isCSymbol and: [value first value == aSymbol]])
	ifTrue:  [value removeFirst]
	ifFalse: [self error: aSymbol, ' expected']
]

"----------------------------------------------------------------"

COperator : Object ()

COperator errorArgumentCount
[
    self error: 'wrong number of arguments'
]


COperatorAdd : COperator ()
