CType : Object ()

CType appliedIn: form
[
    self error: 'cannot apply: ', form printString
]


CUnknownType : CType ()

CUnknownType printOn: aStream
[
    aStream nextPut: $?
]


CObjectType : CType ()


CLambdaType : CType ( result arguments )

CType isLambdaType		[ ^false ]
CLambdaType isLambdaType	[ ^true ]

CLambdaType result		[ ^result ]
CLambdaType arguments		[ ^arguments ]

CLambdaType withResult: resultType arguments: argumentTypes
[
    self := self new.
    result := resultType.
    arguments := argumentTypes.
]

CLambdaType printOn: aStream
[
    aStream nextPutAll: '(('.
    arguments do: [:arg | arg printOn: aStream] separatedBy: [aStream space].
    aStream nextPutAll: ') -> '.
    result printOn: aStream.
    aStream nextPut: $).
]


CScalarType : CType ()


CPointerType : CScalarType ( target )

CPointerType withTarget: targetType
[
    self := self new.
    target := targetType.
]

CPointerType appliedIn: form
[
    ^target isLambdaType ifTrue: [target appliedIn: form] ifFalse: [super appliedIn: form]
]

CPointerType printOn: aStream
[
    target printOn: aStream.
    aStream nextPut: $*
]

CType pointer
[
    ^CPointerType withTarget: self
]

"----------------------------------------------------------------"

CIntegerType : CScalarType ()
[
    CIntegerType := CIntegerType new.
]
