CokeParser : CokeScanner ()

CokeParser parse
[
    | obj |
    obj := self perform: tokenType asSymbol.
    ^obj
]

CokeParser integer
[
    | anInteger |
    anInteger := CInteger readFrom: token contents readStream base: 10.
    self nextToken.
    ^anInteger
]

CokeParser identifier
[
    | id |
    id := CSymbol withValue: token contents asSymbol.
    self nextToken.
    ^id
]

CokeParser open
[
    | list match |
    list := CList new.
    match := matchingToken.
    self nextToken.
    [tokenType ~~ #eof and: [tokenType ~~ #close]] whileTrue: [list add: self parse].
    token contents = match ifFalse: [self error: '''', match, ''' expected near ''', token, ''''].
    self nextToken.
    ^list
]

CokeParser doubleQuote
[
    | obj |
    obj := CString value_: token contents _stringValue.
    self nextToken.
    ^obj
]

CokeParser eof
[
    ^nil
]
