{ import: Object }
{ import: CokeExpression }

CokeTransform : Object ( default listing )

CokeTransform new
[
    ^self withDefault: nil.
]

CokeTransform listing: l	[ listing := l ]

CokeTransform withDefault: defaultSelector
[
    self := super new.
    default := defaultSelector.
    listing := SinkStream.
]

CokeTransform doesNotUnderstand: aSelector	[ ^aSelector == default ifFalse: [self _bind: default] ]

CokeTransform transform: anExpression		[ ^anExpression asExpression transformIn: self ]

SmallInteger	transformIn: aTransform		[ ^aTransform integer: self ]
CokeTransform	integer: anInteger		[ ^self error: 'cannot transform SmallInteger' ]

Symbol		transformIn: aTransform		[ ^aTransform symbol: self ]
CokeTransform	symbol: aSymbol			[ ^self error: 'cannot transform Symbol' ]

String		transformIn: aTransform		[ ^aTransform string: self ]
CokeTransform	string: aString			[ ^self error: 'cannot transform String' ]

Expression	transformIn: aTransform		[ ^aTransform perform: self first with: self ]

CokeTransform begin :expr
[
    listing nextPutAll: 'begin: '; print: expr; cr.
    1 to: expr size - 1 do: [:i | expr at: i put: ((expr at: i) transformIn: self)].
    ^expr
]
