{ import: Object }
{ import: CokeExpression }

Type : Object ( size alignment )
  VoidType : Type ()			Type isVoidType	     [ ^false ]  VoidType     	isVoidType	[ ^true ]
  IntegerType : Type ()			Type isIntegerType   [ ^false ]  IntegerType  	isIntegerType  	[ ^true ]
    UnsignedType : IntegerType ()	Type isUnsignedType  [ ^false ]  UnsignedType 	isUnsignedType 	[ ^true ]
    SignedType : IntegerType ()		Type isSignedType    [ ^false ]  SignedType   	isSignedType   	[ ^true ]
  FloatType : Type ()			Type isFloatType     [ ^false ]  FloatType    	isFloatType    	[ ^true ]
  PointerType : Type ( referent )	Type isPointerType   [ ^false ]  PointerType  	isPointerType  	[ ^true ]
  StructureType : Type ( members )	Type isStructureType [ ^false ]  StructureType  isStructureType [ ^true ]

Type size	[ ^size ]
Type alignment	[ ^alignment ]

Type size: anInteger
[
    self := self new.
    size := alignment := anInteger.
]

Type size: sizeInteger alignment: alignmentInteger
[
    self      := self new.
    size      := sizeInteger.
    alignment := alignmentInteger.
]

PointerType size: anInteger referent: aType	[ ^(self size: anInteger) referent: aType ]
PointerType referent: aType			[ referent := aType ]

Type fullSuffix	[ ^String with: self suffix with: $0 + size ]

Type cType		[ ^UnsignedType size: 1 ]
Type iType		[ ^SignedType size: 4 ]
Type vType		[ ^VoidType size: 1 ]

Type pcType		[ ^PointerType size: 4 referent: self cType ]
Type pvType		[ ^PointerType size: 4 referent: self vType ]

Type fromOperator: op
[
    | t s |
    op := op asString.
    op last == #v ifTrue: [^self vType].
    t := (op at: op size - 2).
    s := (op at: op size - 1) - $0.
    t == $u ifTrue: [^UnsignedType size: s].
    t == $i ifTrue: [^SignedType   size: s].
    t == $f ifTrue: [^FloatType    size: s].
    t == $p ifTrue: [^PointerType  size: s].
    self error: 'unknown type suffix in operator ', op
]

Type printOn: aStream
[
    aStream nextPutAll: self fullSuffix
]

VoidType fullSuffix		[ ^String with: self suffix ]
StructureType fullSuffix	[ ^String with: self suffix ]

VoidType      suffix	[ ^$v ]
UnsignedType  suffix	[ ^$u ]
SignedType    suffix	[ ^$i ]
FloatType     suffix	[ ^$f ]
PointerType   suffix	[ ^$p ]
StructureType suffix	[ ^$b ]

Type = aType	[ ^self suffix == aType suffix and: [size == aType size] ]

Type typeError: aType for: anOperator
[
    StdErr cr;
	nextPutAll: 'illegal operands ';
	print: self; nextPutAll: ' and '; print: aType;
	nextPutAll: ' for operator '; nextPutAll: anOperator asString;
	cr.
    1 exit.
]

Type combine: aType for: anOperator		[ ^self typeError: aType for: anOperator ]

IntegerType combine: aType for: anOperator	[ ^aType combineInteger: self for: anOperator ]

VoidType      printOn: aStream	[ aStream nextPutAll: 'void' ]
UnsignedType  printOn: aStream	[ aStream nextPutAll: 'unsigned' ]
SignedType    printOn: aStream	[ aStream nextPutAll: 'integer' ]
FloatType     printOn: aStream	[ aStream nextPutAll: 'float' ]
PointerType   printOn: aStream	[ aStream nextPutAll: 'pointer' ]
StructureType printOn: aStream	[ aStream nextPutAll: 'struct' ]

UnsignedType combineInteger: aType for: anOperator
[
    ^self size: (size max: aType size)
]

SignedType combineInteger: aType for: anOperator
[
    ^(aType isUnsignedType ifTrue: [aType] ifFalse: [self]) size: (size max: aType size)
]

SignedType convert: expr to: aType
[
    ^expr type = aType ifTrue: [expr] ifFalse: [(Expression with: #cvs with: expr) type: self]
]
