#ifndef __vpu_Deque_h
#define __vpu_Deque_h

#include <assert.h>

#include "List.h"
#include "Heap.h"


template <class Elt_t>
class DLink : public Link<Elt_t>
{
public:
  DLink<Elt_t> *prev;

  DLink(Elt_t *e) : Link<Elt_t>(e) { prev= 0; }
};


template <class Elt_t>
class Deque : public List<Elt_t>
{
public:

  Elt_t *addLast(Heap *heap, Elt_t *elt)
  {
    DLink<Elt_t> *link= new(heap) DLink<Elt_t>(elt);
    if (first == 0)
      {
	assert(last == 0);
	first= last= link;
      }
    else
      {
	assert(last != 0);
	last->next= link;
	link->prev= (DLink<Elt_t> *)last;
	last= link;
      }
    return elt;
  }
};


#endif __vpu_Deque_h
