#ifndef __vpu_Heap_h
#define __vpu_Heap_h

#include <stdlib.h>


class Heap
{
public:
  void   *segment;
  void   *position;
  size_t  size;
  size_t  delta;
  size_t  bytes;
  size_t  objects;

  Heap(void) { segment= position= 0; size= 0; delta= 8*1024; bytes= objects= 0; }
  ~Heap(void);

  void grow(size_t lbs);

  inline void *alloc(size_t lbs)
  {
    if (lbs > size) grow(lbs);
    void *bulk= position;
    position= (void *)((char *)position + lbs);
    size -= lbs;
    bytes += lbs;
    objects++;
    return bulk;
  }
};


class Bulk
{
public:
  inline void *operator new(size_t lbs, Heap *heap) { return heap->alloc(lbs); }
};


#endif // __vpu_Heap_h
