#ifndef __vpu_Stack_h
#define __vpu_Stack_h


#include "List.h"


class Insn;
class Addr;
class Arg;
class Temp;


template <class Elt_t>
class AbstractStack : public List<Elt_t>
{
  void printReversed(Link<Elt_t> *l);

public:
  void print(void)
  {
    if (List<Elt_t>::first) printReversed(List<Elt_t>::first);
  }

  Elt_t *push(Heap *heap, Elt_t *i)
  {
    addFirst(heap, i);
    return i;
  }

  Elt_t *pop(int n= 1)
  {
    Elt_t *e= 0;
    while (n--) e= List<Elt_t>::removeFirst();
    return e;
  }
};


class Stack     : public AbstractStack<Insn> {};
class AddrStack : public AbstractStack<Addr> {};
class ArgStack  : public AbstractStack<Arg>  {};
class TempStack : public AbstractStack<Temp> {};


#endif // __vpu_Stack_h
