#ifndef __vpu_Var_h
#define __vpu_Var_h


#include "Heap.h"
#include "List.h"


class VarList;


class Var : public Bulk
{
public:
  int       offset;	// from frame pointer
  int       size;	// size bytes
  VarList   *list;	// stack zone in which var appears

  Var(int o, int s, VarList *l) { offset= o; size= s; list= l; }

  int  print(void);
  void println(void);
};


class VarList : public List<Var>
{
public:
  int size;

  VarList(void) { size= 0; }

  Var *define(Heap *heap, int offset, int size);

  int  print(void);
  void println(void);
};


#endif // __vpu_Var_h
