#ifndef __vpu_bitops_h
#define __vpu_bitops_h

// find first (rightmost) set bit in mask
// return: LS bit = 1, MS bit = 32, 0 if no bits set

extern int ffs(unsigned mask);
extern int ffsll(unsigned long long mask);

// find last (leftmost) set bit in mask
// return: LS bit = 1, MS bit = 32, 0 if no bits set

extern int fls(unsigned mask);
extern int flsll(unsigned long long mask);

// number of bits set in mask

extern int nbs(unsigned mask);

// bit size of integer
// return: minimum number of bits required to represent n

static inline int simm(int n)         	       { return fls(n ^ (n >> 1)) + 1; }
static inline int uimm(unsigned n)    	       { return fls(n); }
static inline int simmll(long long n) 	       { return flsll(n ^ (n >> 1)) + 1; }
static inline int uimmll(unsigned long long n) { return flsll(n); }

#endif // __vpu_bitops_h
