#ifndef __vpu_error_h
#define __vpu_error_h


extern const char *errorFile;
extern       int   errorLine;
extern const char *errorFunc;
extern	     int   errorFatal;

extern void _error(char *, ...);

#define fatal (									\
  errorFile= __FILE__, errorLine= __LINE__, errorFunc= __PRETTY_FUNCTION__,	\
  errorFatal= 1,								\
  _error									\
)

#define warning (								\
  errorFile= __FILE__, errorLine= __LINE__, errorFunc= __PRETTY_FUNCTION__,	\
  _error									\
)

#define notReached()						\
  fatal("internal VPU error -- please submit a bug report")

#define missing()						\
  fatal("feature not implemented -- go yell at Ian")


#endif // __vpu_error_h
