#ifndef __vpu_types_h
#define __vpu_types_h


// this should be a lattice but we're WAY TOO FLAKEY (and lazy) to be
// bothered with that type of nonsense

#if 0

enum {
  // insn modes
  BOT		= 0x00,	// this MUST be zero!
  VOID		= 0x01,
  BOOL		= 0x02,
  GPR4		= 0x03,
  GPR8		= 0x04,
  FPR4		= 0x05,
  FPR8		= 0x06,
  IVAR4		= 0x07,
  IVAR8		= 0x08,
  FVAR4		= 0x09,
  FVAR8		= 0x0a,
  INT4		= 0x0b,
  INT8		= 0x0c,
  FLT4		= 0x0d,
  FLT8		= 0x0e,
  // masks
  MODEMASK	= 0x0f,
  MODESIZE	=    4,
};

#else

typedef enum Stor { StorLit= 1, StorReg= 2, StorVar= 3 }             Stor;
typedef enum Type { TypeInt= 0, TypeFlt= 1 }			     Type;
typedef enum Size { SizeNul= 0, SizeSgl=  1, SizeDbl= 2, SizeTpl= 3} Size;

#define makeMode(st, ty, sz)	(((st) << 3) | ((ty) << 2) | ((sz) << 0))

static inline Stor modeStor(unsigned mode) { return (Stor)(((mode) >>3)    ); }
static inline Type modeType(unsigned mode) { return (Type)(((mode) >>2) & 1); }
static inline Size modeSize(unsigned mode) { return (Size)(((mode)    ) & 3); }

#define MODESIZE	   5
#define MODEMASK	0x1f

typedef enum Mode {
  BOT=	0,
  VOID=	makeMode(StorLit, TypeInt, SizeNul),
  LI4=	makeMode(StorLit, TypeInt, SizeSgl),
  LI8=	makeMode(StorLit, TypeInt, SizeDbl),
  LF4=	makeMode(StorLit, TypeFlt, SizeSgl),
  LF8=	makeMode(StorLit, TypeFlt, SizeDbl),
  CCR=	makeMode(StorReg, TypeInt, SizeNul),
  RI4=	makeMode(StorReg, TypeInt, SizeSgl),
  RI8=	makeMode(StorReg, TypeInt, SizeDbl),
  RF4=	makeMode(StorReg, TypeFlt, SizeSgl),
  RF8=	makeMode(StorReg, TypeFlt, SizeDbl),
  VI4=	makeMode(StorVar, TypeInt, SizeSgl),
  VI8=	makeMode(StorVar, TypeInt, SizeDbl),
  VF4=	makeMode(StorVar, TypeFlt, SizeSgl),
  VF8=	makeMode(StorVar, TypeFlt, SizeDbl)
} Mode;

#endif


#endif // __vpu_types_h
