{ import: st80 }
{ import: Rectangle }
{ import: Color }

{ include "gl-primdefs.h" }

GL : Object ()

GL glColorBufferBit		{ return _O(GL_COLOR_BUFFER_BIT); }
GL glProjection			{ return _O(GL_PROJECTION); }
GL glFlat			{ return _O(GL_FLAT); }

GL clear_: _mask		{ glClear(_I(v__mask)); }
GL matrixMode_: _mode		{ glMatrixMode(_I(v__mode)); }
GL shadeModel_: _mode		{ glShadeModel(_I(v__mode)); }

GL flush			{ glFlush(); }
GL loadIdentity			{ glLoadIdentity(); }

GLU : GL ()

GLUT : GLU ()

GLUTWindowList : IdentityDictionary ()
[
    GLUTWindowList := GLUTWindowList new.
]

{ include "glut-callback.c" }

GLUT initialize
[
    super initialize.
    windows := IdentityDictionary new.
    {
      int argc= (int)_param(0);
      char **argv= (char **)_param(1);
      glutInit(&argc, argv);
    }.
    self
	initDisplayMode: (self glutDouble bitOr: self glutRGBA);
	clearColor: Color white;
	shadeModel: self glFlat.
]

GLUT glutSingle				{ return _O(GLUT_SINGLE); }
GLUT glutDouble				{ return _O(GLUT_DOUBLE); }
GLUT glutRGBA				{ return _O(GLUT_RGBA); }

GLUT initDisplayMode_: _mode		{ glutInitDisplayMode(_I(v__mode)); }
GLUT initWindowSize_: _x _: _y		{ glutInitWindowSize(_I(v__x), _I(v__y)); }
GLUT initWindowPosition_: _x _: _y	{ glutInitWindowPosition(_I(v__x), _I(v__y)); }

GLUT display				[ ('GLUT display') putln ]
GLUT reshape: w with: h			[ ('GLUT reshape: ', w printString, ' with: ', h printString) putln ]
GLUT keyboard: key with: x with: y	[ ('GLUT keyboard: ', key printString, ' with: ', x printString, ' with: ', y printString) putln ]

GLUT createWindow: labelString bounds: boundingBox
[
    | id |
    id := self
	initWindowPosition: boundingBox origin;
	initWindowSize: boundingBox extent;
	createWindow_: labelString _stringValue.
    {
      glutDisplayFunc(GLUT_display);
      glutReshapeFunc(GLUT_reshape_with_);
      glutKeyboardFunc(GLUT_keyboard_with_with_);
#if 0
      glutSpecialFunc(GLUT_special_with_with_);
      glutMouseFunc(GLUT_mouse_with_with_);
      glutMotionFunc(GLUT_motion_with_);
#endif
    }.
    ^id
]

GLUT createWindow_: _title		{ return _O(glutCreateWindow(_S(v__title))); }

GLUT glutBitmap8by13			{ return (oop)GLUT_BITMAP_8_BY_13; }
GLUT glutBitmap9by15			{ return (oop)GLUT_BITMAP_9_BY_15; }
GLUT glutBitmapTimesRoman10		{ return (oop)GLUT_BITMAP_TIMES_ROMAN_10; }
GLUT glutBitmapTimesRoman24		{ return (oop)GLUT_BITMAP_TIMES_ROMAN_24; }
GLUT glutBitmapHelvetica10		{ return (oop)GLUT_BITMAP_HELVETICA_10; }
GLUT glutBitmapHelvetica12		{ return (oop)GLUT_BITMAP_HELVETICA_12; }
GLUT glutBitmapHelvetica18		{ return (oop)GLUT_BITMAP_HELVETICA_18; }

GLUT bitmapCharacter_: _fontID _: _char	{ glutBitmapCharacter((void *)v__fontID, _I(v__char)); }
GLUT strokeCharacter_: _fontID _: _char	{ glutStrokeCharacter((void *)v__fontID, _I(v__char)); }

GLUT mainLoop				{ glutMainLoop(); }






"
Point glRasterPos		[ self glRasterPos_: x _integerValue _: y _integerValue ]

Point glRasterPos_: _x _: _y	{ glRasterPos2i((GLint)v__x, (GLint)v__y); }


Rectangle glRect
[
    self glRect_: origin x _integerValue
	 _:	  origin y _integerValue
	 _:	  corner x _integerValue
	 _:	  corner y _integerValue
]

Rectangle glRect_: _x1 _: _y1 _: _x2 _: _y2	{ glRecti((GLint)v__x1, (GLint)v__y1, (GLint)v__x2, (GLint)v__y2); }

Rectangle glViewport
[
    self glViewport_: origin x _integerValue
	 _:	      origin y _integerValue
	 _:	      corner x _integerValue
	 _:	      corner y _integerValue
]

Rectangle glViewport_: _x1 _: _y1 _: _x2 _: _y2	{ glViewport((GLint)v__x1, (GLint)v__y1, (GLsizei)v__x2, (GLsizei)v__y2); }

Rectangle glOrtho
[
    self glOrtho_: origin x _integerValue
	 _:	   origin y _integerValue
	 _:	   origin z _integerValue
	 _:	   corner x _integerValue
	 _:	   corner y _integerValue
	 _:	   corner z _integerValue
]

Rectangle glOrtho_: _x1 _: _y1 _: _z1 _: _x2 _: _y2 _: _z2
{
  glOrtho((GLdouble)(int)v__x1, (GLdouble)(int)v__x2,
	  (GLdouble)(int)v__y1, (GLdouble)(int)v__y2,
	  (GLdouble)(int)v__z1, (GLdouble)(int)v__z2);
}



Color glClearColor
{
  glClearColor((GLclampf)(((GLubyte *)self)[0]) / 255.0,
	       (GLclampf)(((GLubyte *)self)[1]) / 255.0,
	       (GLclampf)(((GLubyte *)self)[2]) / 255.0,
	       (GLclampf)(((GLubyte *)self)[3]) / 255.0);
}

Color glColor	{ glColor4ubv((GLubyte *)self); }
"
