{ import: preprocess }

C99Preprocessor sanityCheck	[ macros do: [:assoc | assoc value assertUntainted] ]
C99Macro assertUntainted	[ tainted ifTrue: [self error: 'macro ', name text, ' is tainted at EOF'] ]

[
    | v1 v2 v3 v4 opts options paths argv arg file scanner token cpp prev |
    v1 := v2 := v3 := v4 := false.
    options := C99PreprocessorOptions default.
    paths := OrderedCollection new.
    (opts := IdentityDictionary new)
	at: #'-1' put: [:opt | v1 := true];
	at: #'-2' put: [:opt | v2 := true];
	at: #'-3' put: [:opt | v3 := true];
	at: #'-4' put: [:opt | v4 := true];
	at: #'-E' put: [:opt | v4 := true];
	at: #'-I' put: [:opt | options addSystemSearchPath: argv next];
	at: #'-W' put: [:opt | options warnings: true];
	at: #'-V' put: [:opt | ];
	at: #'-P' put: [:opt | ].
    argv := OS arguments readStream.
    [argv atEnd]
	whileFalse:
	   [arg := argv next.
	    (opts at: arg asSymbol ifAbsent: [[:path | paths add: path]])
		value: arg].
    cpp := C99Preprocessor withOptions: options.
    paths do: [:path |
	file := path = '-' ifTrue: [StdIn readStream] ifFalse: [File open: path].
	scanner := C99Scanner on: file.
	[token := scanner nextToken]
	    whileTrue:
		[v1 ifTrue: [StdOut print: token; cr].
		 cpp add: token].
	file close].
    v2 ifTrue: [cpp do: [:t | t putTextOn: StdOut]].
    [token := cpp nextToken]
	whileTrue:
	    [v3 ifTrue: [StdOut print: token; cr].
	     v4 ifTrue:
		 [token isBlank
		      ifTrue:  [StdOut nextPut: (token isEOL ifTrue: [$\n] ifFalse: [$ ])]
		      ifFalse: [token putTextOn: StdOut]]].
    cpp sanityCheck.
]
