{ import: Object-imp }
{ import: Object-lib }

{ include <errno.h> }
{ include <sys/types.h> }
{ include <sys/socket.h> }
{ include <netinet/in.h> }
{ include <netdb.h> }



ServerSocket : Object ( _socket )

ServerSocket onPort: p
[
    | _p |
    self := self new.
    _p := p _integerValue.
    {
        int one= 1;
	struct sockaddr_in server_info;
	server_info.sin_len = sizeof(server_info);
	server_info.sin_family = AF_INET;
	server_info.sin_addr.s_addr = htonl(INADDR_ANY);
	server_info.sin_port = htons((int)v__p);
	self->v__socket = (oop)socket(AF_INET, SOCK_STREAM, 0);
	if (((int)self->v__socket) < 0) {
	    fprintf(stderr, "error: unable to create socket\n");
	    return (oop)0;
	}
	setsockopt((int)self->v__socket, SOL_SOCKET, SO_REUSEADDR, &one, sizeof(one));
	setsockopt((int)self->v__socket, SOL_SOCKET, SO_REUSEPORT, &one, sizeof(one));
	if (bind((int)self->v__socket, (struct sockaddr *)&server_info, sizeof(server_info)) < 0) {
	    fprintf(stderr, "error: port %d is already in use\n", (int)v__p);
	    return (oop)0;
	}
	if (listen((int)self->v__socket, 3) < 0) {
	    fprintf(stderr, "error: socket listen\n");
	    return (oop)0;
	}
    }
]

ServerSocket accept
[
    | _s |
    {
	struct sockaddr_in client_info;
	unsigned int client_info_size = sizeof(client_info);
	while (1) {
	    v__s = (oop)accept((int)self->v__socket, (struct sockaddr *)&client_info, &client_info_size);
	    if (((int)v__s) < 0) {
		if (errno == EINTR)
		   usleep(10000);
		else {
		    fprintf(stderr, "error: socket accept\n");
		    return (oop)0;
		}
	    }
	    else break;
	}
    }.
    ^File withFd: (SmallInteger value_: _s)
]



Socket : Object ()

Socket toHost: h port: p
[
    | _s _h _p |
    _h := h _stringValue.
    _p := p _integerValue.
    {
	struct hostent *record = gethostbyaddr((char *)v__h, 4, AF_INET);
	if (record == NULL)
	    record = gethostbyname((char *)v__h);
	if (record == NULL) {
	    fprintf(stdout, "error: unable to find the address of host '%s'\n", (char *)v__h);
	    return (oop)0;
	}
	v__s = (oop)socket(AF_INET, SOCK_STREAM, 0);
	if (((int)v__s) < 0) {
	    fprintf(stderr, "error: unable to create socket\n");
	    return (oop)0;
	}
	struct sockaddr_in server_info;
	server_info.sin_len = sizeof(server_info);
	server_info.sin_family = AF_INET;
	server_info.sin_addr.s_addr = ((struct in_addr *)(record->h_addr))->s_addr;
	server_info.sin_port = htons((int)v__p);
	if (connect((int)v__s, (struct sockaddr *)&server_info, sizeof(server_info)) < 0) {
	    fprintf(stderr, "error: unable to connect to %s:%d\n", (char *)v__h, (int)v__p);
	    return (oop)0;
	}
    }.
    ^File withFd: (SmallInteger value_: _s)
]
