{ import: VPU5 }

{ include "asm-i386.h" }

VPU targetString	[ ^'i386 generic' ]

VPU _asmPass		{ return (oop)asm_pass; }
VPU _asmPass_: _n	{ return (oop)(asm_pass= (long)v__n); }
VPU _asmPC		{ return (oop)asm_pc; }
VPU _asmPC_: _n		{ return (oop)(asm_pc= (void *)v__n); }

VPU linkageSize		[ ^8 ]

VPU allocateFrame
[
    tempBase  := paramCount  * 4.
    stackBase := tempCount  * 4 + tempBase.
    frameSize := (paramCount + tempCount + stackCount) * 4 + self linkageSize + 15 bitAnd: 0xffff0.
    argBase   := frameSize.	"args relative to %esp"
]

IEnter	emit: vpu
[
    | frameSize |
    frameSize := vpu frameSize.
    { 
	PUSHLr	(_EBP);
	MOVLrr	(_ESP, _EBP);
	SUBLir	((((long)v_frameSize >> 1) - 8), _ESP);

#	define ARG()	(((long)self->v_argLocation >> 1)	   )
#	define TMP()	(((long)self->v_tmpLocation >> 1)	   )
#	define LOC(N)	(((long)self->v_location    >> 1) + ((N)*4))
    }.
]

Ret	emit: vpu	{ MOVLmr	(	LOC(1),_ESP,0,0, _EAX);
			  LEAVE		();
			  RET		(); }

ITmp	emit: vpu	{ MOVLim	(0, TMP(),_ESP,0,0); }

LdFP	emit: vpu	[ | _loc | _loc := (vpu frameSize - 8) _integerValue.
			{ LEALmr	((long)v__loc,_ESP,0,0, _EAX);
			  MOVLrm	(_EAX, LOC(0),_ESP,0,0	    ); } ]

LdInt	emit: vpu	[ | _int | _int := value _integerValue.
			{ MOVLim	((long)v__int, LOC(0),_ESP,0,0); } ]

LdPtr	emit: vpu	{ MOVLim	((long)self->v_value	 , LOC(0),_ESP,0,0); }

LdArg	emit: vpu	{ MOVLmr	(	ARG( ),_ESP,0,0, _EAX);
			  MOVLrm	(_EAX,	LOC(0),_ESP,0,0	     ); }

StArg	emit: vpu	{ MOVLmr	(	LOC(0),_ESP,0,0, _EAX);
			  MOVLrm	(_EAX,	ARG( ),_ESP,0,0	     ); }

LdTmp	emit: vpu	{ MOVLmr	(	TMP( ),_ESP,0,0, _EAX);
			  MOVLrm	(_EAX,	LOC(0),_ESP,0,0	     ); }

StTmp	emit: vpu	{ MOVLmr	(	LOC(0),_ESP,0,0, _EAX);
			  MOVLrm	(_EAX,	TMP( ),_ESP,0,0	     ); }

Dup	emit: vpu	{ MOVLmr	(      LOC(-1),_ESP,0,0, _EAX);
			  MOVLrm	(_EAX,	LOC(0),_ESP,0,0	     ); }

Rdb	emit: vpu	{ MOVLmr	(	LOC(0),_ESP,0,0, _EAX);
			  MOVZBLmr	(	   (0),_EAX,0,0, _EAX);
			  MOVLrm	(_EAX,	LOC(0),_ESP,0,0	     ); }

Rdh	emit: vpu	{ MOVLmr	(	LOC(0),_ESP,0,0, _EAX);
			  MOVZWLmr	(	   (0),_EAX,0,0, _EAX);
			  MOVLrm	(_EAX,	LOC(0),_ESP,0,0	     ); }

Rdw	emit: vpu	{ MOVLmr	(	LOC(0),_ESP,0,0, _EAX);
			  MOVLmr	(	   (0),_EAX,0,0, _EAX);
			  MOVLrm	(_EAX,	LOC(0),_ESP,0,0	     ); }

Wrb	emit: vpu	{ MOVLmr	(	LOC(0),_ESP,0,0, _EAX);
			  MOVLmr	(	LOC(1),_ESP,0,0, _ECX);
			  MOVBrm	(_AL,	   (0),_ECX,0,0	     ); }

Wrh	emit: vpu	{ MOVLmr	(	LOC(0),_ESP,0,0, _EAX);
			  MOVLmr	(	LOC(1),_ESP,0,0, _ECX);
			  MOVWrm	(_AX,	   (0),_ECX,0,0	     ); }

Wrw	emit: vpu	{ MOVLmr	(	LOC(0),_ESP,0,0, _EAX);
			  MOVLmr	(	LOC(1),_ESP,0,0, _ECX);
			  MOVLrm	(_EAX,	   (0),_ECX,0,0	     ); }

Add	emit: vpu	{ MOVLmr	(	LOC(1),_ESP,0,0, _EAX);
			  ADDLrm	(_EAX,	LOC(0),_ESP,0,0	     ); }

Sub	emit: vpu	{ MOVLmr	(	LOC(1),_ESP,0,0, _EAX);
			  SUBLrm	(_EAX,	LOC(0),_ESP,0,0	     ); }

Mul	emit: vpu	{ MOVLmr	(	LOC(1),_ESP,0,0, _EAX);
			  IMULLmr	(	LOC(0),_ESP,0,0, _EAX);
			  MOVLrm	(_EAX,	LOC(0),_ESP,0,0	     ); }

Div	emit: vpu	{ MOVLmr	(	LOC(0),_ESP,0,0, _EAX);
			  CLTD		();
			  IDIVLmr	(	LOC(1),_ESP,0,0, _EAX);
			  MOVLrm	(_EAX,	LOC(0),_ESP,0,0	     ); }

Mod	emit: vpu	{ MOVLmr	(	LOC(0),_ESP,0,0, _EAX);
			  CLTD		();
			  IDIVLmr	(	LOC(1),_ESP,0,0, _EAX);
			  MOVLrm	(_EDX,	LOC(0),_ESP,0,0	     ); }

And	emit: vpu	{ MOVLmr	(	LOC(1),_ESP,0,0, _EAX);
			  ANDLrm	(_EAX,	LOC(0),_ESP,0,0	     ); }

Or	emit: vpu	{ MOVLmr	(	LOC(1),_ESP,0,0, _EAX);
			  ORLrm		(_EAX,	LOC(0),_ESP,0,0	     ); }

Xor	emit: vpu	{ MOVLmr	(	LOC(1),_ESP,0,0, _EAX);
			  XORLrm	(_EAX,	LOC(0),_ESP,0,0	     ); }

Lsl	emit: vpu	{ MOVLmr	(	LOC(1),_ESP,0,0, _ECX);
			  SHLLrm	(_CL,	LOC(0),_ESP,0,0	     ); }

Lsr	emit: vpu	{ MOVLmr	(	LOC(1),_ESP,0,0, _ECX);
			  SHRLrm	(_CL,	LOC(0),_ESP,0,0	     ); }

Asr	emit: vpu	{ MOVLmr	(	LOC(1),_ESP,0,0, _ECX);
			  SARLrm	(_CL,	LOC(0),_ESP,0,0	     ); }

Lt	emit: vpu	{ MOVLmr	(	LOC(0),_ESP,0,0, _EAX);
			  CMPLmr	(	LOC(1),_ESP,0,0, _EAX);
			  SETLr		(_AL);
			  MOVZBLrr	(_AL,	_EAX);
			  MOVLrm	(_EAX,	LOC(0),_ESP,0,0); }

Le	emit: vpu	{ MOVLmr	(	LOC(0),_ESP,0,0, _EAX);
			  CMPLmr	(	LOC(1),_ESP,0,0, _EAX);
			  SETLEr	(_AL);
			  MOVZBLrr	(_AL,	_EAX);
			  MOVLrm	(_EAX,	LOC(0),_ESP,0,0); }

Eq	emit: vpu	{ MOVLmr	(	LOC(0),_ESP,0,0, _EAX);
			  CMPLmr	(	LOC(1),_ESP,0,0, _EAX);
			  SETEr		(_AL);
			  MOVZBLrr	(_AL,	_EAX);
			  MOVLrm	(_EAX,	LOC(0),_ESP,0,0); }

Ne	emit: vpu	{ MOVLmr	(	LOC(0),_ESP,0,0, _EAX);
			  CMPLmr	(	LOC(1),_ESP,0,0, _EAX);
			  SETNEr	(_AL);
			  MOVZBLrr	(_AL,	_EAX);
			  MOVLrm	(_EAX,	LOC(0),_ESP,0,0); }

Ge	emit: vpu	{ MOVLmr	(	LOC(0),_ESP,0,0, _EAX);
			  CMPLmr	(	LOC(1),_ESP,0,0, _EAX);
			  SETGEr	(_AL);
			  MOVZBLrr	(_AL,	_EAX);
			  MOVLrm	(_EAX,	LOC(0),_ESP,0,0); }

Gt	emit: vpu	{ MOVLmr	(	LOC(0),_ESP,0,0, _EAX);
			  CMPLmr	(	LOC(1),_ESP,0,0, _EAX);
			  SETGr		(_AL);
			  MOVZBLrr	(_AL,	_EAX);
			  MOVLrm	(_EAX,	LOC(0),_ESP,0,0); }

Not	emit: vpu	{ XORLrr	(_EAX,	_EAX);
			  CMPLim	(0,	LOC(0),_ESP,0,0);
			  SETEr		(_AL);
			  MOVLrm	(_EAX,	LOC(0),_ESP,0,0); }

Br	emit: vpu
[
    | _addr |
    _addr := label _address.	{ JMPm		(v__addr,0,0,0); }
]

Bt	emit: vpu
[
    | _addr |
    _addr := label _address.	{ CMPLim	(0,	LOC(1),_ESP,0,0);
				  JNEm		(	  v__addr,0,0,0); }
]

Bf	emit: vpu
[
    | _addr |
    _addr := label _address.	{ CMPLim	(0,	LOC(1),_ESP,0,0);
				  JEm		(	  v__addr,0,0,0); }
]

ICall	emit: vpu
[
    | _addr |
    _addr := label _address.
    {
	int arity= (long)self->v_arity >> 1;
	int i;
	for (i= 0;  i < arity;	++i) {	MOVLmr	(	LOC(arity - i - 1),_ESP,0,0, _EAX);
					MOVLrm	(_EAX,	   (	    4 * i),_ESP,0,0	 );  }
				  CALLm		(		   v__addr,0   ,0,0	 );
				  MOVLrm	(_EAX,	LOC(		0),_ESP,0,0	 );
    }.
]

ICalli	emit: vpu
[
    {
	int arity= (long)self->v_arity >> 1;
	int i;
	for (i= 0;  i < arity;	++i) {	MOVLmr	(	LOC(arity - i - 1),_ESP,0,0, _EAX);
					MOVLrm	(_EAX,	   (	    4 * i),_ESP,0,0	 );  }
				  MOVLmr	(	LOC(arity	 ),_ESP,0,0, _EAX);
				  CALLm		(	   (		0),_EAX,0,0	 );
				  MOVLrm	(_EAX,	LOC(		0),_ESP,0,0	 );
    }.
]

VPU flush_: _first to_: _last	{ iflush((insn *)v__first, (insn *)v__last); }


{ (void)_W; (void)_D1; (void)_D4; }	"defined but not used"

"----------------------------------------------------------------"

"{ import: VPU-i386-dsm }"

VPU disassemble_: _first to_: _last	[]
