{ import: Object }

{ include "lib/cvpu.h" }


VPU : Object ( _vpu )

VPU malloc: fn		{ vpu_setMalloc((void *)v_fn); }
VPU free: fn		{ vpu_setFree((void *)v_fn); }

VPU new
[
    self := super new.
    _vpu := self _new.
]

VPU _new		{ return (oop)vpu_new(); }

VPU note: n		[]	" xxx COMPAT xxx "

VPU newLocalLabel	{ return (oop)vpu_newLocalLabel((CVPU *)self->v__vpu); }
VPU defineLocalLabel: l	{ vpu_DefineLocalLabel((CVPU *)self->v__vpu, (void *)v_l); }

VPU defineLabel: l	[ self defineLabel_: l _labelValue ]
VPU defineLabel_: _l	{ vpu_DefineLabel((CVPU *)self->v__vpu, (CLabel *)v__l); }

VPU begin: n		{ vpu_Begin((CVPU *)self->v__vpu, (long)v_n >> 1); }
VPU define: n		{ vpu_Define((CVPU *)self->v__vpu, (long)v_n >> 1); }
VPU end: n		{ vpu_End((CVPU *)self->v__vpu, (long)v_n >> 1); }

VPU iEnter		{ vpu_Ienter((CVPU *)self->v__vpu); }
VPU iArg		{ vpu_Iarg((CVPU *)self->v__vpu, 1); }
VPU iArg: n		{ vpu_Iarg((CVPU *)self->v__vpu, (long)v_n >> 1); }

VPU iTmp		[ self iTmp: 1 ]
VPU iTmp: n		{ vpu_Itmp((CVPU *)self->v__vpu, (long)v_n >> 1); }
VPU dropTmp: n		{ vpu_DropTmp((CVPU *)self->v__vpu, (long)v_n >> 1); }

VPU ldFP		{ vpu_LdFP((CVPU *)self->v__vpu); }

VPU ldInt: n		{ vpu_LdInt((CVPU *)self->v__vpu, (long)v_n >> 1); }
VPU ldPtr: p		{ vpu_LdPtr((CVPU *)self->v__vpu, (void *)v_p); }

VPU ldArg: n		{ vpu_LdArg((CVPU *)self->v__vpu, (long)v_n >> 1); }
VPU stArg: n		{ vpu_StArg((CVPU *)self->v__vpu, (long)v_n >> 1); }
VPU ldTmp: n		{ vpu_LdTmp((CVPU *)self->v__vpu, (long)v_n >> 1); }
VPU stTmp: n		{ vpu_StTmp((CVPU *)self->v__vpu, (long)v_n >> 1); }

VPU dup			[ self dup: 0 ]
VPU dup: n		{ vpu_Dup((CVPU *)self->v__vpu, (long)v_n >> 1); }
VPU drop		[ self drop: 1 ]
VPU drop: n		{ vpu_Drop((CVPU *)self->v__vpu, (long)v_n >> 1); }

VPU rdb			{ vpu_Rdb((CVPU *)self->v__vpu); }
VPU rdh			{ vpu_Rdh((CVPU *)self->v__vpu); }
VPU rdw			{ vpu_Rdw((CVPU *)self->v__vpu); }
VPU wrb			{ vpu_Wrb((CVPU *)self->v__vpu); }
VPU wrh			{ vpu_Wrh((CVPU *)self->v__vpu); }
VPU wrw			{ vpu_Wrw((CVPU *)self->v__vpu); }

VPU add			{ vpu_Add((CVPU *)self->v__vpu); }
VPU sub			{ vpu_Sub((CVPU *)self->v__vpu); }
VPU mul			{ vpu_Mul((CVPU *)self->v__vpu); }
VPU div			{ vpu_Div((CVPU *)self->v__vpu); }
VPU mod			{ vpu_Mod((CVPU *)self->v__vpu); }

VPU and			{ vpu_And((CVPU *)self->v__vpu); }
VPU or			{ vpu_Or ((CVPU *)self->v__vpu); }
VPU xor			{ vpu_Xor((CVPU *)self->v__vpu); }

VPU lsl			{ vpu_Lsl((CVPU *)self->v__vpu); }
VPU lsr			{ vpu_Lsr((CVPU *)self->v__vpu); }

VPU lt			{ vpu_Lt((CVPU *)self->v__vpu); }
VPU le			{ vpu_Le((CVPU *)self->v__vpu); }
VPU eq			{ vpu_Eq((CVPU *)self->v__vpu); }
VPU ne			{ vpu_Ne((CVPU *)self->v__vpu); }
VPU ge			{ vpu_Ge((CVPU *)self->v__vpu); }
VPU gt			{ vpu_Gt((CVPU *)self->v__vpu); }
VPU not			{ vpu_Not((CVPU *)self->v__vpu); }

VPU br: l		{ vpu_Br((CVPU *)self->v__vpu, (long)v_l >> 1); }
VPU bt: l		{ vpu_Bt((CVPU *)self->v__vpu, (long)v_l >> 1); }
VPU bf: l		{ vpu_Bf((CVPU *)self->v__vpu, (long)v_l >> 1); }

VPU brLocal: l		{ vpu_BrLocal((CVPU *)self->v__vpu, (void *)v_l); }

VPU iCall: n label: l	[ self iCall: n label_: l _labelValue ]
VPU iCall: n label_: _l	{ vpu_IcallLabel((CVPU *)self->v__vpu, (long)v_n >> 1, (CLabel *)v__l); }
VPU iCalli: n		{ vpu_Icalli((CVPU *)self->v__vpu, (long)v_n >> 1); }

VPU ret			{ vpu_Ret((CVPU *)self->v__vpu); }

VPU compile		[ self  compile: 0 debug: 0 ]
VPU compile: c		[ self  compile: c debug: 0 ]
VPU compile: c debug: d { vpu_compile((CVPU *)self->v__vpu, (long)v_c >> 1, (long)v_d >> 1); }

VPU iflush_: _a to_: _b	{ vpu_iflush((void *)v__a, (void *)v__b); }

VPU codeSize		{ return (oop)(vpu_codeSize((CVPU *)self->v__vpu) << 1 | 1); }

VPU versionString	[ ^String value_: self _versionString ]
VPU _versionString	{ return (oop)vpu_versionString((CVPU *)self->v__vpu); }

"----------------------------------------------------------------"

VPULabel : Object ( _label )

VPULabel new
[
    self := super new.
    _label := self _new.
]

VPULabel lookup: name
[
    self := self new.
    self _labelAddress_: name asSymbol _dlsym
]

VPULabel _new			{ return (oop)label_new(); }

VPULabel _labelValue		{ return self->v__label; }
VPULabel _labelAddress		{ return (oop)label_getAddress((CLabel *)self->v__label); }
VPULabel _labelAddress_: _addr	{ return (oop)label_setAddress((CLabel *)self->v__label, (void *)v__addr); }

VPULabel value			{ return (oop)label_call0((CLabel *)self->v__label); }
VPULabel value:	a		{ return (oop)label_call1((CLabel *)self->v__label, (long)v_a >> 1); }
