document.write("<H2>JavaScript Performance Benchmark</H2>");
document.write("This web page is a simple benchmark for JavaScript analogous to (and directly comparable with) Squeak's tinyBenchmarks.  It reports results in terms of operations/sec (simple things like addition and subscripting) and sends/sec (user-defined message to a user-defined object).<BR><BR>");
var opBenchmark = function (nReps) {
	var size = 8190; var count;
	for(var iter= 0; iter<nReps; iter++) {
		count = 0;
		flags = new Array(size);
		for(var i=0; i<size; i++) flags[i]= true;
		for(var i=1; i<=size; i++) {
			if(flags[i-1]) {
				var prime = i+1;
				var k = i + prime;
				while(k <= size) {
					flags[k-1] = false;
					k = k + prime; }
				count = count + 1; }}}
	return count; };

var msDiff = function (t1, t0) { return ((t1.getSeconds()*1000) + t1.getMilliseconds())
					- ((t0.getSeconds()*1000) + t0.getMilliseconds()); };

Number.prototype.fib = function() {
	if (this < 2) return 1;
	else return (self - 1).fib() + (self - 2).fib();
};

var tinyBenchmarks = function () {
	var t0, t1, n1, n2, n3, result, time;
	n1= 1;
	do {n1= n1*2;
		t0= new Date();
		result= opBenchmark(n1);
		t1= new Date();
		var time1= msDiff(t1, t0);
		document.write("n1 = " + n1 + "; time = " + time1 + " milliseconds; "
			+ ((n1 * 500000 * 1000) / time1).toFixed(0) + " operations/sec.<BR>"); }
	while (time1 < 500);
	document.write("<BR>");

	n2= 23;
	do {n2= n2+1;
		t0= new Date();
		result= (new Fibber(1)).fib(n2);
		t1= new Date();
		var time2= msDiff(t1, t0);
		document.write("n2 = " + n2 + "; time = " + time2 + " milliseconds; "
			+ (((result * 1000) / time2)).toFixed(0) + " sends/sec.<BR>"); }
	while (time2 < 500);

	n3= 23;
	do {n3= n3+1;
		t0= new Date();
		result= n3.fib();
		t1= new Date();
		var time2= msDiff(t1, t0);
		document.write("n3 = " + n3 + "; time = " + time2 + " milliseconds; "
			+ (((result * 1000) / time2)).toFixed(0) + " sends/sec.<BR>"); }
	while (time2 < 500);
};

tinyBenchmarks();

document.write("<BR>Each test is run for successively longer times until it takes half a second or more, to ensure a meaningful run time on machines of different speed.  Generally the last line in the series will be your best measure.  Have fun trying this on different machines and browsers.<BR><BR>");
document.write("Occasionally you may see a result that is much worse that the others, and this is likely due either to garbage collection or to some other interruption from the operating system.  In that case, ignore the result, and rerun the tests if desired by simply reloading this page.<BR><BR>");
document.write("If you want to find out more, just view the source -- this page *is* the benchmark program.<BR><BR>  - Dan Ingalls  4/12/2006");

