var win = new Surface(new Point(100, 100).extent(new Point(800, 600))),
    pix = win.newPixmap(win.extent()),
    cs = pix.createCairoSurface(),
    cr = cs.createContext(),
    lastPoint = new Point(180, 45),
    track = null,
    done = false;

Event.prototype.doIt = function() {
};

ExposeEvent.prototype.doIt = function() {
  draw();
};

MotionEvent.prototype.doIt = function() {
  if (!track)
    return;
  lastPoint = lastPoint + this.position() - track;
  track = this.position();
  draw();
};

ButtonPressEvent.prototype.doIt = function() {
  if ((lastPoint - this.position()).getR() < 15)
    track = this.position();
};

ButtonReleaseEvent.prototype.doIt = function() {
  track = null;
};

KeyReleaseEvent.prototype.doIt = function() {
  if (this.keyCode() == 27)
    done = 1;
};

function draw() {
  cr.identityMatrix();
  cr.setSourceRGB(1, 1, 1); cr.rectangle(new Point(0, 0).extent(win.extent())); cr.fill();
  cr.setLineWidth(0.01);
  cr.setSourceRGB(0.5, 0.5, 0.5);
  cr.selectFont("Sans", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_NORMAL);
  cr.setFontSize(7); cr.moveTo(new Point(100, 100));
  cr.showText("Behind the ostensible government sits enthroned an invisible government owing no");
  cr.setFontSize(8); cr.moveTo(new Point(100, 120));
  cr.showText("allegiance and acknowledging no responsibility to the people. To destroy this");
  cr.setFontSize(9); cr.moveTo(new Point(100, 140));
  cr.showText("invisible government, to befoul the unholy alliance between corrupt business and");
  cr.setFontSize(10); cr.moveTo(new Point(100, 160));
  cr.showText("corrupt politics is the first task of the statesmanship of today.");
  cr.setFontSize(11); cr.moveTo(new Point(100, 180)); cr.showText("(President Theodore Roosevelt, 19 April 1906)");
  cr.setSourceRGBA(1, 0, 0, 0.5); cr.rectangle(new Point(100, 170).extent(new Point(100, 100))); cr.fill();
  cr.setSourceRGBA(0, 1, 0, 0.5); cr.rectangle(new Point(130, 200).extent(new Point(100, 100))); cr.fill();
  cr.setSourceRGBA(0, 0, 1, 0.5); cr.rectangle(new Point(160, 230).extent(new Point(100, 100))); cr.fill();
  cr.setSourceRGBA(0.25, 0.25, 0.25, 0.95);
  cr.setFontSize(15); cr.moveTo(new Point(20, 320));
  cr.showText("Behind the ostensible government sits enthroned an invisible government owing no");
  cr.setFontSize(16); cr.moveTo(new Point(20, 340));
  cr.showText("allegiance and acknowledging no responsibility to the people. To destroy this");
  cr.setFontSize(17); cr.moveTo(new Point(20, 360));
  cr.showText("invisible government, to befoul the unholy alliance between corrupt business and");
  cr.setFontSize(18); cr.moveTo(new Point(20, 380));
  cr.showText("corrupt politics is the first task of the statesmanship of today.");
  cr.setFontSize(19); cr.moveTo(new Point(20, 400));
  cr.showText("(President Theodore Roosevelt, 19 April 1906)");
  cr.setSourceRGBA(1, 0, 0, 0.5);
  cr.arc(new Point(50, 285), 15, 0, 2 * Math.PI); cr.fill();
  cr.arc(lastPoint, 15, 0, 2 * Math.PI); cr.fill();
  cr.setLineWidth(12);
  cr.setLineCap(CAIRO_LINE_CAP_ROUND);
  cr.moveTo(new Point(50, 285));
  cr.relLineTo(new Point(300, 0));
  cr.relLineTo(new Point(0, 185));
  cr.relLineTo(new Point(-170, 0));
  cr.lineTo(lastPoint);
  cr.stroke();
  cr.setFontSize(15); cr.moveTo(new Point(50, 500)); cr.showText("press ESCAPE to exit");
  cr.setFontSize(15); cr.moveTo(lastPoint + new Point(20, 5)); cr.showText("<-- drag me with the mouse");
  pix.draw(win, new Point(0, 0));
}

while (!done) {
  var e = win.waitEvent();
  // document.write(e);
  e.doIt();
}
