#[StdErr nextPutAll: '"Parsing and compiling Cairo bindings... "];

#[OS _import: "cairo-xlib" "__id__init__cairo_2dxlib"];
#[OS _import: "Window-lib" "__id__init__Window_2dlib"];

#(define Point (import "Point"));
function Point(x, y) { this = #[Point withX: (js-get _ctxt 'x) y: (js-get _ctxt 'y)]; }
#(define PointProto (js-get (js-get _ctxt 'Point) 'prototype));
#(makeJSType Point PointProto);
Point.prototype.getX = function() { return #[(js-get _ctxt 'this) x]; };
Point.prototype.getY = function() { return #[(js-get _ctxt 'this) y]; };
Point.prototype.getR = function() { return #[(js-get _ctxt 'this) r]; };
Point.prototype["+"] = #(lambda (this that)
			  [Point withX: (js-bsend '+ [this x] (js-send 'getX that))
				     y: (js-bsend '+ [this y] (js-send 'getY that))]);
Point.prototype["-"] = #(lambda (this that)
			  [Point withX: (js-bsend '- [this x] (js-send 'getX that))
				     y: (js-bsend '- [this y] (js-send 'getY that))]);
Point.prototype.extent = function(that) { return #[(js-get _ctxt 'this) extent: (js-get _ctxt 'that)]; };

#(define Rectangle (import "Rectangle"));
function Rectangle(origin, corner) { this = #[Rectangle withOrigin: (js-get _ctxt 'origin) corner: (js-get _ctxt 'corner)]; }
#(define RectangleProto (js-get (js-get _ctxt 'Rectangle) 'prototype));
#(makeJSType Rectangle RectangleProto);
Rectangle.prototype.getOrigin = function() { return #[(js-get _ctxt 'this) origin]; };
Rectangle.prototype.getCorner = function() { return #[(js-get _ctxt 'this) corner]; };
Rectangle.prototype.getExtent = function() { return #[(js-get _ctxt 'this) extent]; };

#(define Surface (import "Surface"));
function Surface(box) { this = #[Surface new: (js-get _ctxt 'box)]; }
#(define SurfaceProto (js-get (js-get _ctxt 'Surface) 'prototype));
#(makeJSType Surface SurfaceProto);
Surface.prototype.newPixmap = function(extent) { return #[(js-get _ctxt 'this) newPixmap: (js-get _ctxt 'extent)]; };
Surface.prototype.extent = function() { return #[(js-get _ctxt 'this) extent]; };
Surface.prototype.createCairoSurface = function() { return #[(js-get _ctxt 'this) createCairoSurface]; };
Surface.prototype.draw = function(s, p) { #[(js-get _ctxt 'this) drawOn: (js-get _ctxt 's) at: (js-get _ctxt 'p)]; };
Surface.prototype.drawLine = function(p1, p2) { #[(js-get _ctxt 'this) drawLine: (js-get _ctxt 'p1) to: (js-get _ctxt 'p2)]; };
Surface.prototype.lineWidth = function(w) { #[(js-get _ctxt 'this) lineWidth: (js-get _ctxt 'w)]; };
Surface.prototype.foreground = function(c) { #[(js-get _ctxt 'this) foreground: (js-get _ctxt 'c)]; };
Surface.prototype.fillRectangle = function(r) { #[(js-get _ctxt 'this) fillRectangle: (js-get _ctxt 'r)]; };
Surface.prototype.waitEvent = function() { return #[(js-get _ctxt 'this) waitEvent]; };
Surface.prototype.pollEvent = function() { return #[(js-get _ctxt 'this) pollEvent]; };
Surface.prototype.flush = function() { return #[(js-get _ctxt 'this) flush]; };
Surface.prototype.sync = function() { return #[(js-get _ctxt 'this) sync]; };

#(define CairoSurface (import "CairoSurface"));
function CairoSurface() { #[OS error: '"CairoSurface does not have a constructor."]; }
#(define CairoSurfaceProto (js-get (js-get _ctxt 'CairoSurface) 'prototype));
#(makeJSType CairoSurface CairoSurfaceProto);
CairoSurface.prototype.createContext = function() { return #[(js-get _ctxt 'this) createContext]; };

#(define CairoContext (import "CairoContext"));
function CairoContext() { #[OS error: '"CairoContext does not have a constructor."]; }
#(define CairoContextProto (js-get (js-get _ctxt 'CairoContext) 'prototype));
#(makeJSType CairoContext CairoContextProto);
CairoContext.prototype.setSourceRGB = function(r, g, b) { #[(js-get _ctxt 'this) setSourceR: (js-get _ctxt 'r)
											  G: (js-get _ctxt 'g)
											  B: (js-get _ctxt 'b)]; };
CairoContext.prototype.setSourceRGBA = function(r, g, b, a) { #[(js-get _ctxt 'this) setSourceR: (js-get _ctxt 'r)
											      G: (js-get _ctxt 'g)
											      B: (js-get _ctxt 'b)
											      A: (js-get _ctxt 'a)]; };
CairoContext.prototype.lineTo = function(p) { #[(js-get _ctxt 'this) lineTo: (js-get _ctxt 'p)]; };
CairoContext.prototype.relLineTo = function(p) { #[(js-get _ctxt 'this) relLineTo: (js-get _ctxt 'p)]; };
CairoContext.prototype.moveTo = function(p) { #[(js-get _ctxt 'this) moveTo: (js-get _ctxt 'p)]; };
CairoContext.prototype.arc = function(p, r, f, t) { #[(js-get _ctxt 'this) arc: (js-get _ctxt 'p)
									radius: (js-get _ctxt 'r)
									  from: (js-get _ctxt 'f)
									    to: (js-get _ctxt 't)]; };
CairoContext.prototype.setLineWidth = function(w) { #[(js-get _ctxt 'this) setLineWidth: (js-get _ctxt 'w)]; };
CairoContext.prototype.setLineCap = function(c) { #[(js-get _ctxt 'this) setLineCap: (js-get _ctxt 'c)]; };
CairoContext.prototype.setFontSize = function(s) { #[(js-get _ctxt 'this) setFontSize: (js-get _ctxt 's)]; };
CairoContext.prototype.selectFont = function(f, s, w) { #[(js-get _ctxt 'this) selectFontFace: (js-get _ctxt 'f)
											slant: (js-get _ctxt 's)
										       weight: (js-get _ctxt 'w)]; };
CairoContext.prototype.showText = function(t) { #[(js-get _ctxt 'this) showText: (js-get _ctxt 't)]; };
CairoContext.prototype.rectangle = function(r) { #[(js-get _ctxt 'this) rectangle: (js-get _ctxt 'r)]; };
CairoContext.prototype.identityMatrix = function() { #[(js-get _ctxt 'this) identityMatrix]; };
CairoContext.prototype.fill = function() { #[(js-get _ctxt 'this) fill]; };
CairoContext.prototype.stroke = function() { #[(js-get _ctxt 'this) stroke]; };

#(define Event (import "Event"));
function Event() { #[OS error: '"Event does not have a constructor."]; }
#(define EventProto (js-get (js-get _ctxt 'Event) 'prototype));
#(makeJSType Event EventProto);
Event.prototype.position = function() { return #[(js-get _ctxt 'this) position]; };

#(define ExposeEvent (import "ExposeEvent"));
function ExposeEvent() { #[OS error: '"ExposeEvent does not have a constructor."]; }
ExposeEvent.prototype = new Object();
ExposeEvent.prototype.__proto__ = Event.prototype;
ExposeEvent.prototype.__class__ = "ExposeEvent";
#(define ExposeEventProto (js-get (js-get _ctxt 'ExposeEvent) 'prototype));
#(makeJSType ExposeEvent ExposeEventProto);

#(define MotionEvent (import "MotionEvent"));
function MotionEvent() { #[OS error: '"MotionEvent does not have a constructor."]; }
MotionEvent.prototype = new Object();
MotionEvent.prototype.__proto__ = Event.prototype;
MotionEvent.prototype.__class__ = "MotionEvent";
#(define MotionEventProto (js-get (js-get _ctxt 'MotionEvent) 'prototype));
#(makeJSType MotionEvent MotionEventProto);

#(define ButtonPressEvent (import "ButtonPressEvent"));
function ButtonPressEvent() { #[OS error: '"ButtonPressEvent does not have a constructor."]; }
ButtonPressEvent.prototype = new Object();
ButtonPressEvent.prototype.__proto__ = Event.prototype;
ButtonPressEvent.prototype.__class__ = "ButtonPressEvent";
#(define ButtonPressEventProto (js-get (js-get _ctxt 'ButtonPressEvent) 'prototype));
#(makeJSType ButtonPressEvent ButtonPressEventProto);

#(define ButtonReleaseEvent (import "ButtonReleaseEvent"));
function ButtonReleaseEvent() { #[OS error: '"ButtonReleaseEvent does not have a constructor."]; }
ButtonReleaseEvent.prototype = new Object();
ButtonReleaseEvent.prototype.__proto__ = Event.prototype;
ButtonReleaseEvent.prototype.__class__ = "ButtonReleaseEvent";
#(define ButtonReleaseEventProto (js-get (js-get _ctxt 'ButtonReleaseEvent) 'prototype));
#(makeJSType ButtonReleaseEvent ButtonReleaseEventProto);

#(define KeyPressEvent (import "KeyPressEvent"));
function KeyPressEvent() { #[OS error: '"KeyPressEvent does not have a constructor."]; }
KeyPressEvent.prototype = new Object();
KeyPressEvent.prototype.__proto__ = Event.prototype;
KeyPressEvent.prototype.__class__ = "KeyPressEvent";
#(define KeyPressEventProto (js-get (js-get _ctxt 'KeyPressEvent) 'prototype));
#(makeJSType KeyPressEvent KeyPressEventProto);
KeyPressEvent.prototype.keyCode = function() { return #[(js-get _ctxt 'this) keyCode]; };

#(define KeyReleaseEvent (import "KeyReleaseEvent"));
function KeyReleaseEvent() { #[OS error: '"KeyReleaseEvent does not have a constructor."]; }
KeyReleaseEvent.prototype = new Object();
KeyReleaseEvent.prototype.__proto__ = Event.prototype;
KeyReleaseEvent.prototype.__class__ = "KeyReleaseEvent";
#(define KeyReleaseEventProto (js-get (js-get _ctxt 'KeyReleaseEvent) 'prototype));
#(makeJSType KeyReleaseEvent KeyReleaseEventProto);
KeyReleaseEvent.prototype.keyCode = function() { return #[(js-get _ctxt 'this) keyCode]; };

CAIRO_FONT_SLANT_NORMAL	= #[CairoContext CAIRO_FONT_SLANT_NORMAL];
CAIRO_FONT_WEIGHT_NORMAL = #[CairoContext CAIRO_FONT_WEIGHT_NORMAL];
CAIRO_LINE_CAP_ROUND = #[CairoContext CAIRO_LINE_CAP_ROUND];

#[StdErr nextPutAll: '"done.\n"];
