#[StdErr nextPutAll: '"Parsing and compiling Canvas bindings... "];

#[OS _import: "Window-lib" "__id__init__Window_2dlib"];
#[OS _import: "Window-x11" "__id__init__Window_2dx11"];

#(define Point (import "Point"));
function Point(x, y) { this = #[Point withX: (js-get _ctxt 'x) y: (js-get _ctxt 'y)]; }
#(define PointProto (js-get (js-get _ctxt 'Point) 'prototype));
#(makeJSType Point PointProto);
Point.prototype.getX = function() { return #[(js-get _ctxt 'this) x]; };
Point.prototype.getY = function() { return #[(js-get _ctxt 'this) y]; };
Point.prototype.getR = function() { return #[(js-get _ctxt 'this) r]; };
Point.prototype["+"] = #(lambda (this that)
			  [Point withX: (js-bsend '+ [this x] (js-send 'getX that))
				     y: (js-bsend '+ [this y] (js-send 'getY that))]);
Point.prototype["-"] = #(lambda (this that)
			  [Point withX: (js-bsend '- [this x] (js-send 'getX that))
				     y: (js-bsend '- [this y] (js-send 'getY that))]);
Point.prototype.extent = function(that) { return #[(js-get _ctxt 'this) extent: (js-get _ctxt 'that)]; };

#(define Rectangle (import "Rectangle"));
function Rectangle(origin, corner) { this = #[Rectangle withOrigin: (js-get _ctxt 'origin) corner: (js-get _ctxt 'corner)]; }
#(define RectangleProto (js-get (js-get _ctxt 'Rectangle) 'prototype));
#(makeJSType Rectangle RectangleProto);
Rectangle.prototype.getOrigin = function() { return #[(js-get _ctxt 'this) origin]; };
Rectangle.prototype.getCorner = function() { return #[(js-get _ctxt 'this) corner]; };
Rectangle.prototype.getExtent = function() { return #[(js-get _ctxt 'this) extent]; };

#(define Canvas (import "Surface"));
function Canvas(x, y, w, h) { this = #[Canvas new: [[(js-get _ctxt 'x)@(js-get _ctxt 'y)]
					   extent: [(js-get _ctxt 'w)@(js-get _ctxt 'h)]]]; }
#(define CanvasProto (js-get (js-get _ctxt 'Canvas) 'prototype));
#(makeJSType Canvas CanvasProto);
Canvas.prototype.foreground = function(c) { #[(js-get _ctxt 'this) foreground: (js-get _ctxt 'c)]; };
Canvas.prototype.clearRect = function(x, y, w, h) {
  this.foreground(0);
  #[(js-get _ctxt 'this) fillRectangle: [[(js-get _ctxt 'x)@(js-get _ctxt 'y)] extent: [(js-get _ctxt 'w)@(js-get _ctxt 'h)]]];
};

#[StdErr nextPutAll: '"done\n"];
