{ import: Object-imp }
{ import: Object-lib }
{ import: CokeScanner }
{ import: Expression }
{ import: compile }

ParserInput : Object ( pos charsRead stream stack )

ParserInput initialize
[
    pos := 0.
    charsRead := OrderedCollection new.
    stack := OrderedCollection new.
]

ParserInput on: aCollection
[
    self := self new initialize.
    stream := aCollection readStream.
]

ParserInput next
[
    pos < charsRead size ifTrue: [pos := pos + 1. ^charsRead at: pos - 1].
    pos = charsRead size ifTrue: [(charsRead size > 0 and: [charsRead last isNil])
					ifFalse: [charsRead add: stream next.
						  pos := pos + 1].
				  ^charsRead last].
    OS error: 'impossible error in ParserInput.next'.
]

ParserInput savePos			[ stack addLast: pos. "StdOut nextPutAll: 'saved pos='; print: pos; cr" ]
ParserInput restorePos			[ pos := stack last. "StdOut nextPutAll: 'restored pos='; print: pos; cr" ]
ParserInput discardPos			[ stack removeLast. "StdOut nextPutAll: 'discarded saved pos'; cr" ]

ParserInput forget
[
    pos > 0
	ifTrue: [| tmp |
		 "StdOut nextPutAll: 'forgetting ', pos asString; cr."
		 tmp := OrderedCollection new.
		 pos to: charsRead size - 1 do: [:idx | tmp add: (charsRead at: idx)]. "because copyFrom is broken!"
		 charsRead := tmp.
		 pos := 0]
]

File mustOpen: aString
[
    | r |
    r := File open: aString.
    r isNil ifTrue: [OS error: 'cannot open ', aString].
    ^r.
]

input : Object ()

File next
[
    | buffer |
    ^(self read: (buffer := String new: 1)) == 1 ifTrue: [buffer first]
]

[
    | scanner buffer expr |
    OS arguments size = 0 ifTrue: [input := StdIn].
    OS arguments size = 1
	ifTrue:
	   [input := File mustOpen: OS arguments first.
	    (input next == $# and: [input next == $!])
		ifTrue:  [[input next == $\n] whileFalse]
		ifFalse: [input rewind]].
    OS arguments size > 1 ifTrue: [OS error: 'usage: ParserInput [file-name]'].
    scanner := CokeScanner on: (File mustOpen: 'mcoke.k') readStream.
    [(expr := scanner next) isNil] whileFalse: [expr eval].
]
"
[
    | script |
    OS argumentCount == 2 ifFalse: [OS error: 'usage: ', OS argumentVector first, ' script-name'].
    script := (File open: OS argumentVector second) readStream.
    StdOut nextPutAll: 'Content-Type: text/plain\n\n'.
    [script next == $\n] whileFalse.
    [script atEnd] whileFalse: [StdOut nextPut: script next].
]
"
