extern "C" {
#include "cvpu.h"
};

#include "VPU.h"
#include "Label.h"

void  vpu_setMalloc(void *fn)		{ VPU::malloc = (VPU::Malloc)fn; }
void  vpu_setFree(void *fn)		{ VPU::free   = (VPU::Free)fn; }

CVPU *vpu_new(void)			{ return (CVPU *)(new VPU); }

CLabel *label_new(void)			{ return (CLabel *)(new Label); }

CVPU *vpu_Begin (CVPU *vpu, int n)	{ return (CVPU *)(((VPU *)vpu)->Begin (n)); }
CVPU *vpu_Define(CVPU *vpu, int n)	{ return (CVPU *)(((VPU *)vpu)->Define(n)); }
CVPU *vpu_End   (CVPU *vpu, int n= 1)	{ return (CVPU *)(((VPU *)vpu)->End   (n)); }

CVPU *vpu_DefineLabel(CVPU *vpu, CLabel *l)	{ return (CVPU *)(((VPU *)vpu)->Define((Label *)l)); }

void *vpu_newLocalLabel(CVPU *vpu)		{ return (((VPU *)vpu)->newLabel()); }
CVPU *vpu_DefineLocalLabel(CVPU *vpu, void *l)	{ return (CVPU *)(((VPU *)vpu)->Define((LocalLabel *)l)); }

// function, args, temps

CVPU *vpu_Ienter  (CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Ienter()); }
CVPU *vpu_Lenter  (CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Lenter()); }
CVPU *vpu_Iarg 	  (CVPU *vpu, int n)	{ return (CVPU *)(((VPU *)vpu)->Iarg(n)); }
CVPU *vpu_Larg 	  (CVPU *vpu, int n)	{ return (CVPU *)(((VPU *)vpu)->Larg(n)); }
CVPU *vpu_Itmp 	  (CVPU *vpu, int n)	{ return (CVPU *)(((VPU *)vpu)->Itmp(n)); }
CVPU *vpu_Ltmp 	  (CVPU *vpu, int n)	{ return (CVPU *)(((VPU *)vpu)->Ltmp(n)); }
CVPU *vpu_LdArg	  (CVPU *vpu, int n)	{ return (CVPU *)(((VPU *)vpu)->LdArg(n)); }
CVPU *vpu_StArg	  (CVPU *vpu, int n)	{ return (CVPU *)(((VPU *)vpu)->StArg(n)); }
CVPU *vpu_LdTmp	  (CVPU *vpu, int n)	{ return (CVPU *)(((VPU *)vpu)->LdTmp(n)); }
CVPU *vpu_StTmp	  (CVPU *vpu, int n)	{ return (CVPU *)(((VPU *)vpu)->StTmp(n)); }
CVPU *vpu_DropTmp (CVPU *vpu, int n)	{ return (CVPU *)(((VPU *)vpu)->DropTmp(n)); }
CVPU *vpu_LdFP    (CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->LdFP()); }
CVPU *vpu_AddrTmp (CVPU *vpu, int n)	{ return (CVPU *)(((VPU *)vpu)->AddrTmp(n)); }
CVPU *vpu_AddrArg (CVPU *vpu, int n)	{ return (CVPU *)(((VPU *)vpu)->AddrArg(n)); }
CVPU *vpu_SaveArgs(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->SaveArgs()); }
CVPU *vpu_Alloc   (CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Alloc()); }

// stack

CVPU *vpu_LdInt(CVPU *vpu, int i)	{ return (CVPU *)(((VPU *)vpu)->Ld  (i)); }
CVPU *vpu_LdStr(CVPU *vpu, char *s)	{ return (CVPU *)(((VPU *)vpu)->Ld  (s)); }
CVPU *vpu_LdPtr(CVPU *vpu, void *p)	{ return (CVPU *)(((VPU *)vpu)->Ld  (p)); }
CVPU *vpu_Dup  (CVPU *vpu, int n)	{ return (CVPU *)(((VPU *)vpu)->Dup (n)); }
CVPU *vpu_Put  (CVPU *vpu, int n)	{ return (CVPU *)(((VPU *)vpu)->Put (n)); }
CVPU *vpu_Drop (CVPU *vpu, int n= 1)	{ return (CVPU *)(((VPU *)vpu)->Drop(n)); }

// conditional

CVPU *vpu_Lt (CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Lt ()); }
CVPU *vpu_Le (CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Le ()); }
CVPU *vpu_Eq (CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Eq ()); }
CVPU *vpu_Ne (CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Ne ()); }
CVPU *vpu_Ge (CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Ge ()); }
CVPU *vpu_Gt (CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Gt ()); }
CVPU *vpu_Not(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Not()); }

CVPU *vpu_Bf(CVPU *vpu, int n)		{ return (CVPU *)(((VPU *)vpu)->Bf(n)); }
CVPU *vpu_Bt(CVPU *vpu, int n)		{ return (CVPU *)(((VPU *)vpu)->Bt(n)); }
CVPU *vpu_Br(CVPU *vpu, int n)		{ return (CVPU *)(((VPU *)vpu)->Br(n)); }
CVPU *vpu_BrLocal(CVPU *vpu, void *l)	{ return (CVPU *)(((VPU *)vpu)->Br((LocalLabel *)l)); }
CVPU *vpu_Bi(CVPU *vpu)			{ return (CVPU *)(((VPU *)vpu)->Br()); }

// call

CVPU *vpu_Icalli(CVPU *vpu, int n)			{ return (CVPU *)(((VPU *)vpu)->Icall(n)); }
CVPU *vpu_Icall(CVPU *vpu, int n, void *fn)		{ return (CVPU *)(((VPU *)vpu)->Icall(n, fn)); }
CVPU *vpu_IcallLabel(CVPU *vpu, int n, CLabel *l)	{ return (CVPU *)(((VPU *)vpu)->Icall(n, (Label *)l)); }
CVPU *vpu_Ret(CVPU *vpu)				{ return (CVPU *)(((VPU *)vpu)->Ret()); }

// arithmetic

CVPU *vpu_Icvt(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Icvt()); }
CVPU *vpu_Neg (CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Neg ()); }

CVPU *vpu_Add(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Add()); }
CVPU *vpu_Sub(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Sub()); }
CVPU *vpu_Div(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Div()); }
CVPU *vpu_Mul(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Mul()); }
CVPU *vpu_Mod(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Mod()); }
CVPU *vpu_And(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->And()); }
CVPU *vpu_Or (CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Or ()); }
CVPU *vpu_Xor(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Xor()); }
CVPU *vpu_Asl(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Asl()); }
CVPU *vpu_Asr(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Asr()); }
CVPU *vpu_Lsl(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Lsl()); }
CVPU *vpu_Lsr(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Lsr()); }

// memory

CVPU *vpu_Rdb(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Rdb()); }
CVPU *vpu_Rdh(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Rdh()); }
CVPU *vpu_Rdw(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Rdw()); }
CVPU *vpu_Wrb(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Wrb()); }
CVPU *vpu_Wrh(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Wrh()); }
CVPU *vpu_Wrw(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->Wrw()); }

CVPU *vpu_dump(CVPU *vpu)		{ return (CVPU *)(((VPU *)vpu)->dump()); }

void *vpu_compile(CVPU *vpu, unsigned flags= 0, unsigned debug= 0)
{
  return (CVPU *)(((VPU *)vpu)->compile(flags, debug));
}

int vpu_codeSize(CVPU *vpu)
{
  return ((VPU *)vpu)->codeSize();
}

char *vpu_versionString(CVPU *vpu)
{
  return ((VPU *)vpu)->versionString;
}

void *label_getAddress(CLabel *l)		{ return ((Label *)l)->value; }
void *label_setAddress(CLabel *l, void *a)	{ return ((Label *)l)->value= a; }
int   label_call0(CLabel *l)			{ return (*((Label *)l))(); }
int   label_call1(CLabel *l, int a)		{ return (*((Label *)l))(a); }


#if defined(__i386__)					  /**** i386  ****/

void vpu_iflush(void *first, void *last)	{}

#elif defined(__PPC__) || defined(__ppc__) || defined(_POWER) || defined(_IBMR2)

void vpu_iflush(register void *addr, register void *last)
{
  register unsigned int *dptr= (unsigned int *)addr;
  while (dptr < (unsigned int *)last) {
    asm volatile ("dcbst 0,%0": :"r"(dptr));
    ++dptr;
  }
  asm volatile ("sync");
  dptr= (unsigned int *)addr;
  while (dptr < (unsigned int *)last) {
    asm volatile ("icbi 0,%0": :"r"(dptr));
    ++dptr;
  }
  asm volatile ("sync;isync");
}

#elif defined(__sparc__)				  /**** Sparc ****/

static void vpu_iflush(register insn *addr, register insn *last)
{
  asm volatile ("stbar");			/* PSO memory model */
  while (addr < last) {
    asm volatile ("flush %0": :"r"(addr));	/* all memory models */
    ++addr;	/* conservative */
  }
  /* [SPARC Architecture Manual v8, page 139, implementation note #5] */
  asm volatile ("nop; nop; nop; nop; nop");
}

#else

# error "don't know how to dync d- and i-cache"

#endif
