" monty.st -- internal object support for Monty Python "

{ import: Object-imp }
{ import: Object-lib }

MontyDelegateList : OrderedCollection ()

MontyDelegateList addDelegate: aMontyObject
[
    | delegates |
    delegates := aMontyObject at: #__delegates__.
    self
	remove:     aMontyObject ifAbsent: [];
	removeAll:  delegates    ifAbsent: [];
	addLast:    aMontyObject;
	addAllLast: delegates.
]

MontyDelegateList attributeAt: aKey
[
    ^self detect:   [:delegate | delegate at: aKey ifAbsent: []]
	  ifAbsent: [self error: 'Monty: undefined variable: ', aKey asString]
]

MontyObject : FastIdentityDictionary ()

MontyObject new: nameString
[
    (self := super new: 3) at: #__delegates__ put: MontyDelegateList new.
]

MontyObject addDelegate: aMontyObject	[ (self at: #__delegates__) addDelegate: aMontyObject ]

MontyObject attributeAt: aKey
[
    | aValue |
    aValue := self at: aKey ifAbsent: [(self at: #__delegates__) attributeAt: aKey].
    "StdOut print: aKey; nextPutAll: ' -> '; print: aValue; cr."
    ^aValue
]

MontyObject attributeAt: aKey put: aValue
[
    "StdOut print: aKey; nextPutAll: ' <= '; print: aValue; cr."
    ^self at: aKey put: aValue
]

"[
    | A B C Y Z X |

    Y := MontyObject new: 'Y'.  Y at: #y put: 4.
    A := MontyObject new: 'A'.  A at: #a put: 1.
    A addDelegate: Y.

    Z := MontyObject new: 'Z'.  Z at: #z put: 5.
    B := MontyObject new: 'B'.  B at: #b put: 2.
    B addDelegate: Z.

    C := MontyObject new: 'C'.  C at: #c put: 3.
    C addDelegate: Y.

    X := MontyObject new: 'X'.  X at: #x put: 6.
    X	addDelegate: A;
	addDelegate: B;
	addDelegate: C.

    StdOut print: (X attributeAt: #a); cr.
    StdOut print: (X attributeAt: #b); cr.
    StdOut print: (X attributeAt: #c); cr.
    StdOut print: (X attributeAt: #x); cr.
    StdOut print: (X attributeAt: #y); cr.
    StdOut print: (X attributeAt: #z); cr.
    StdOut print: (X attributeAt: #d); cr.
]"
