{ import: Object-imp }
{ import: Object-lib }
{ import: Window-lib }

"================================================================"

RandomForPicking := [ Random new ]

Collection atRandom	[ ^self atRandom: RandomForPicking ]

SequenceableCollection atRandom: random	[ ^self at: (random nextInt: self size) ]

{ import: Window-x11 }

Surface rectangles
[
    | colors random w h pt1 pt2 r evt |
    colors := #(0x000000 0xff0000 0x00ff00 0x0000ff).
    random := Random new.
    w := self width.
    h := self height.
    [(evt := self pollEvent) notNil and: [evt isKeyPress]]
	whileFalse:
	   [pt1 := (random next * w) asInteger @ (random next * h) asInteger.
	    pt2 := (random next * w) asInteger @ (random next * h) asInteger.
	    r := Rectangle encompassing: (Array with: pt1 with: pt2).
	    "evt notNil ifTrue: ["
	    self
		foreground: colors atRandom;
		fillRectangle: r;
		foreground: 0;
		drawRectangle: r;
		flush
		"]"].
]

Surface lines
[
    | colors random w h pt1 pt2 evt |
    colors := #(0x000000 0xff0000 0x00ff00 0x0000ff).
    random := Random new.
    w := self width.
    h := self height.
    [(evt := self pollEvent) notNil and: [evt isKeyPress]]
	whileFalse:
	   [pt1 := (random next * w) asInteger @ (random next * h) asInteger.
	    pt2 := (random next * w) asInteger @ (random next * h) asInteger.
	    "evt notNil ifTrue: ["
	    self
		foreground: colors atRandom;
		drawLine: pt1 to: pt2;
		flush
		"]"].
]

Surface ellipses
[
    | colors random w h pt1 pt2 evt |
    colors := #(0x000000 0xff0000 0x00ff00 0x0000ff).
    random := Random new.
    w := self width.
    h := self height.
    [(evt := self pollEvent) notNil and: [evt isKeyPress]]
	whileFalse:
	   [pt1 := (random next * w) asInteger @ (random next * h) asInteger.
	    pt2 := (random next * w) asInteger @ (random next * h) asInteger.
	    pt2 := pt2 - pt1.
	    pt2 := pt2 max: (5@5).
	    "evt notNil ifTrue: ["
	    self
		foreground: colors atRandom;
		fillArc: pt1 extent: pt2 from: 0 to: 64*360;
		foreground: 0;
		drawArc: pt1 extent: pt2 from: 0 to: 64*360;
		flush
		"]"].
]

Surface pause
[
    | evt |
    [(evt := self pollEvent) notNil and: [evt isKeyPress]] whileFalse.
]

Surface doodle
[
    | colors pt1 down evt |
    colors := #(0xff0000 0x00ff00 0x0000ff 0xffff00 0xff00ff 0x00ffff).
    down := false.
    [(evt := self waitEvent) notNil and: [evt isKeyPress]]
	whileFalse:
	   [evt isButtonPress   ifTrue: [down := true].
	    evt isButtonRelease ifTrue: [down := false].
	    (evt notNil and: [down])
		ifTrue:
		   [self
			foreground: colors atRandom;
			drawArc: evt position - (5@5) extent: 10@10 from: 0 to: 64*360;
			foreground: 0;
			drawPoint: evt position;
			sync]]
]

Surface textle
[
    | colors pt1 evt |
    colors := #(0xff0000 0x00ff00 0x0000ff 0xffff00 0xff00ff 0x00ffff).
    [(evt := self waitEvent) notNil and: [evt isKeyPress]]
	whileFalse:
	   [evt isMotion
		ifTrue:
		   [self
			foreground: 0x000000;
			fillRectangle: (0@0 corner: 100@18);
			foreground: 0xffffff;
			drawString: evt position printString at: 4@16;
			foreground: colors atRandom;
			drawString: 'Doodle away!' at: evt position;
			sync]]
]

Surface wormle
[
    | colors w h dx dy random worm index head rect evt |
    colors := #(0xff0000 0x00ff00 0x0000ff 0xffff00 0xff00ff 0x00ffff).
    w      := self width.
    h      := self height.
    head   := 0@0.
    dx     := 1.
    dy     := 1.
    random := Random new.
    worm   := Array new: 100.
    index  := 0.
    [(evt := self pollEvent) notNil and: [evt isKeyPress]]
	whileFalse:
	   [(rect := worm at: index) notNil ifTrue: [self foreground: 0x000000; fillRectangle: rect].
	    rect  := head extent: 7@7.
	    worm at: index put: rect.
	    (index := index + 1) >= worm size ifTrue: [index := 0].
	    self
		foreground: 0x000000;
		fillRectangle: (100@100 extent: 64@16);
		foreground: 0x00ff00;
		drawString: head printString at: 102@114;
		foreground: colors atRandom;
		fillRectangle: rect.
	    head x < 0 ifTrue: [dx := (random next *  5) asInteger + 3].
	    head x > w ifTrue: [dx := (random next * -5) asInteger - 3].
	    head y < 0 ifTrue: [dy := (random next *  5) asInteger + 3].
	    head y > h ifTrue: [dy := (random next * -5) asInteger - 3].
	    head := head + (dx @ dy).
	    OS usleep: 1000].
]

Surface rotate
[
    | colors x y d a p q tr tl br bl evt |
    colors := #(0xff0000 0x00ff00 0x0000ff 0xffff00 0xff00ff 0x00ffff).
    x      := self width // 2.
    y      := self height // 2.
    d      := 200.
    a      := 0.0.
    self lineWidth: 5.
    [(evt := self pollEvent) notNil and: [evt isKeyPress]]
	whileFalse:
	   [p  := (d * a sin) asInteger.
	    q  := (d * a cos) asInteger.
	    tr := (x + p) @ (y + q).
	    tl := (x - q) @ (y + p).
	    bl := (x - p) @ (y - q).
	    br := (x + q) @ (y - p).
	    self
		foreground: 0x000000;
		drawLine: tr to: tl; drawLine: tl to: bl; drawLine: bl to: br; drawLine: br to: tr.
	    a  := a + 0.00025.
	    p  := (d * a sin) asInteger.
	    q  := (d * a cos) asInteger.
	    tr := (x + p) @ (y + q).
	    tl := (x - q) @ (y + p).
	    bl := (x - p) @ (y - q).
	    br := (x + q) @ (y - p).
	    self
		foreground: colors atRandom;
		drawLine: tr to: tl; drawLine: tl to: bl; drawLine: bl to: br; drawLine: br to: tr;
		sync]
]

Surface drag
[
    | rect position down evt |
    rect := 100@100 corner: 150@150.
    down := false.
    self lineWidth: 4.
    [(evt := self pollEvent) notNil and: [evt isKeyPress]]
	whileFalse:
	   [self
		foreground: 0xffffff; fillRectangle: rect;
		foreground: (down ifTrue: [0xff0000] ifFalse: [0x000000]); drawRectangle: rect;
		foreground: 0x000000; drawString: rect origin printString at: rect origin + (4@16); sync.
	    evt notNil
		ifTrue:
		   [position := evt position.
		    (evt isButtonPress and: [rect contains: position])
			ifTrue: [down := position].
		    (evt isMotion and: [down notNil])
			ifTrue:
			   [self foreground: 0; fillRectangle: rect; drawRectangle: rect.
			    rect := rect translatedBy: position - down.
			    down := position].
		    (evt isButtonRelease)
			ifTrue: [down := nil]]]
]

{ import: Matrix }

Surface spin
[
    | cube vertices a b c da db dc world twoPi dz evt down now then nframes fps aSin aCos bSin bCos cSin cCos count |
    (cube := Array new: 8)
	at: 0 put: (Vector4 with: 0.0 with: 1.0 with: 1.0 with:	1.0);
	at: 1 put: (Vector4 with: 0.0 with: 0.0 with: 1.0 with:	1.0);
	at: 2 put: (Vector4 with: 0.0 with: 0.0 with: 0.0 with:	1.0);
	at: 3 put: (Vector4 with: 0.0 with: 1.0 with: 0.0 with:	1.0);
	at: 4 put: (Vector4 with: 1.0 with: 1.0 with: 1.0 with:	1.0);
	at: 5 put: (Vector4 with: 1.0 with: 0.0 with: 1.0 with:	1.0);
	at: 6 put: (Vector4 with: 1.0 with: 0.0 with: 0.0 with:	1.0);
	at: 7 put: (Vector4 with: 1.0 with: 1.0 with: 0.0 with:	1.0).
    a := b := c := 0.0.
    da := 0.0023.
    db := 0.0013.
    dc := 0.0001.
    down := false.
    self lineWidth: 4.
    twoPi := 3.1415926536 * 2.0.
    now := then := 0.
    nframes := fps := 0.
    count := 0.
    [(evt := self pollEvent) notNil and: [evt isKeyPress]]
	whileFalse:
	   [aSin := a sin.  aCos := a cos.  bSin := b sin.  bCos := b cos.  cSin := c sin.  cCos := c cos.
	    world := Matrix4x4
		with: (cCos * bCos)				with: ( -1.0 * cSin * bCos)			with:        bSin		with: 3.00
		with: (cCos * bSin * aSin) + (cSin * aCos)	with: ((cCos * aCos) - (cSin * bSin * aSin))	with: -1.0 * bCos * aSin  	with: 2.00
		with: (cSin * aSin) - (cCos * bSin * aCos)	with: ((cSin * bSin * aCos) + (aSin * cCos))	with:        bCos * aCos  	with: 5.00
		with: 0.0					with: 0.0					with: 0.0			with: 1.0.
	    vertices := cube collect: [:vertex | world * vertex].
	    vertices := vertices collect: [:vertex |
		dz := down ifTrue: [vertex z] ifFalse: [5.0].
		((500.0 * vertex x / dz) asInteger @ (500.0 * vertex y / dz) asInteger)].
	    self
		clearArea: (0@0 corner: 700@500);
		foreground: 0xffffff; drawLine: (vertices at: 0) to: (vertices at: 1);
		foreground: 0xff0000; drawLine: (vertices at: 1) to: (vertices at: 2);
		foreground: 0x00ff00; drawLine: (vertices at: 2) to: (vertices at: 3);
		foreground: 0x0000ff; drawLine: (vertices at: 3) to: (vertices at: 0);
		foreground: 0xffffff; drawLine: (vertices at: 4) to: (vertices at: 5);
		foreground: 0xff0000; drawLine: (vertices at: 5) to: (vertices at: 6);
		foreground: 0x00ff00; drawLine: (vertices at: 6) to: (vertices at: 7);
		foreground: 0x0000ff; drawLine: (vertices at: 7) to: (vertices at: 4);
		foreground: 0xffffff; drawLine: (vertices at: 0) to: (vertices at: 4);
		foreground: 0xff0000; drawLine: (vertices at: 1) to: (vertices at: 5);
		foreground: 0x00ff00; drawLine: (vertices at: 2) to: (vertices at: 6);
		foreground: 0x0000ff; drawLine: (vertices at: 3) to: (vertices at: 7).
	    nframes := nframes + 1.
	    (evt notNil and: [evt isButtonPress]) ifTrue: [down := true].
	    (evt notNil and: [evt isButtonRelease]) ifTrue: [down := false].
	    down
		ifTrue:
		   [self
			foreground: 0x00ff00;
			drawString: (a) printString at: 8@20;
			drawString: (b) printString at: 8@40;
			drawString: (c) printString at: 8@60;
			drawString: fps printString, ' fps' at: 8@80.
		    now := Time millisecondClockValue.
		    now - then > 1000
			ifTrue:
			   [fps := nframes.
			    then := now.
			    nframes := 0]].
	    (count := count + 1) >= 30
		ifTrue:
		   [count := 0.
		    self sync].
	    (a := a + da) > twoPi ifTrue: [a := a - twoPi].
	    (b := b + db) > twoPi ifTrue: [b := b - twoPi].
	    (c := c + dc) > twoPi ifTrue: [c := c - twoPi]]
]

Surface spew
[
    | gnd sky num rnd index world pts from to div pix vel acc tmp evt |
    num := 255.
    pts := Array new: num.
    vel := Array new: num.
    acc := Array new: num.
    tmp := Array new: num.
    rnd := Random new.
    sky := 0@0   corner: 800@250.
    gnd := 0@250 corner: 800@600.
    0 to: num - 1 do: [:i |
	pts at: i put: (Vector4 with: 0.0 with: 0.0 with: 0.0 with: 1.0).
	vel at: i put: (Vector4 with: 0.0 with: 0.0 with: 0.0 with: 1.0).
	acc at: i put: (Vector4 with: 0.0 with: 0.0 with: 0.0 with: 1.0).
	tmp at: i put: 255].
    self lineWidth: 2.
    world := Vector4 with: 400.0 with: 300.0 with: 10.0 with: 0.0.
    index := 0.
    [(evt := self pollEvent) notNil and: [evt isKeyPress]]
	whileFalse:
	   [self
		foreground: 0x202040; fillRectangle: sky;
		foreground: 0x204020; fillRectangle: gnd;
		foreground: 0xffe000; fillArc: 390@295 extent: 20@10 from: 0 to: 64*360.
	    0 to: num - 1 do: [:i |
		from := pts at: i.
		to   := from + (vel at: i).
		pts at: i put: to.
		from := from + world.
		to   := to   + world.
		div  := from  z * 0.1.
		from := (from x / div) asInteger @ (from y / div) asInteger.
		div  := to    z * 0.1.
		to   := (to   x / div) asInteger @ (to   y / div) asInteger.
		pix  := tmp at: i.
		pix  := (0xff0000) + (pix * 0x100) + 0x40.
		self foreground: pix; drawLine: from to: to.
		vel at: i put: ((vel  at: i) + (acc at: i)).
		tmp at: i put: (tmp at: i) - 1].
	    pts at: index put: (Vector4 with: 0.0 with:   0.0 with: 0.0 with: 1.0).
	    vel at: index put: (Vector4 with: (rnd next - 0.5) * 2.0 with: rnd next - 5.5 with: 0.0 with: 1.0).
	    acc at: index put: (Vector4 with: 0.0 with:  0.05 with: 0.0 with: 1.0).
	    tmp at: index put: 255.
	    (index := index + 1) >= num ifTrue: [index := 0].
	    self flush].
]

"
Surface gl
[
    | glx |
    glx := self glxCreateContext.
    StdOut nextPutAll: 'glx ok'; cr.
]
"

[
    | window |
    window := Surface new: (100@100 extent: 800@600).
    window clear; pause.
    window clear; lines.
    window clear; rectangles.
    window clear; ellipses.
    window clear; doodle.
    window clear; textle.
    window clear; wormle.
    window clear; rotate.
    window clear; drag.
    window clear; spin.
    window clear; spew.
    "window clear; gl."
    window close.
]
