{ import: SqueakVM }

SqueakVM bytecodeTable
[
    ^#(
	(  0  15 pushReceiverVariableBytecode)
	( 16  31 pushTemporaryVariableBytecode)
	( 32  63 pushLiteralConstantBytecode)
	( 64  95 pushLiteralVariableBytecode)
	( 96 103 storeAndPopReceiverVariableBytecode)
	(104 111 storeAndPopTemporaryVariableBytecode)
	(112	 pushReceiverBytecode)
	(113	 pushConstantTrueBytecode)
	(114	 pushConstantFalseBytecode)
	(115	 pushConstantNilBytecode)
	(116	 pushConstantMinusOneBytecode)
	(117	 pushConstantZeroBytecode)
	(118	 pushConstantOneBytecode)
	(119	 pushConstantTwoBytecode)
	(120	 returnReceiver)
	(121	 returnTrue)
	(122	 returnFalse)
	(123	 returnNil)
	(124	 returnTopFromMethod)
	(125	 returnTopFromBlock)
	(126	 unknownBytecode)
	(127	 unknownBytecode)
	(128	 extendedPushBytecode)
	(129	 extendedStoreBytecode)
	(130	 extendedStoreAndPopBytecode)
	(131	 singleExtendedSendBytecode)
	(132	 doubleExtendedDoAnythingBytecode)
	(133	 singleExtendedSuperBytecode)
	(134	 secondExtendedSendBytecode)
	(135	 popStackBytecode)
	(136	 duplicateTopBytecode)
	(137	 pushActiveContextBytecode)
	(138 143 experimentalBytecode)
	(144 151 shortUnconditionalJump)
	(152 159 shortConditionalJump)
	(160 167 longUnconditionalJump)
	(168 171 longJumpIfTrue)
	(172 175 longJumpIfFalse)
	"176-191 sendArithmeticSelectorBytecode"
	(176	 bytecodePrimAdd)
	(177	 bytecodePrimSubtract)
	(178	 bytecodePrimLessThan)
	(179	 bytecodePrimGreaterThan)
	(180	 bytecodePrimLessOrEqual)
	(181	 bytecodePrimGreaterOrEqual)
	(182	 bytecodePrimEqual)
	(183	 bytecodePrimNotEqual)
	(184	 bytecodePrimMultiply)
	(185	 bytecodePrimDivide)
	(186	 bytecodePrimMod)
	(187	 bytecodePrimMakePoint)
	(188	 bytecodePrimBitShift)
	(189	 bytecodePrimDiv)
	(190	 bytecodePrimBitAnd)
	(191	 bytecodePrimBitOr)	
	"192-207 sendCommonSelectorBytecode"
	(192	 bytecodePrimAt)
	(193	 bytecodePrimAtPut)
	(194	 bytecodePrimSize)
	(195	 bytecodePrimNext)
	(196	 bytecodePrimNextPut)
	(197	 bytecodePrimAtEnd)
	(198	 bytecodePrimEquivalent)
	(199	 bytecodePrimClass)
	(200	 bytecodePrimBlockCopy)
	(201	 bytecodePrimValue)
	(202	 bytecodePrimValueWithArg)
	(203	 bytecodePrimDo)
	(204	 bytecodePrimNew)
	(205	 bytecodePrimNewWithArg)
	(206	 bytecodePrimPointX)
	(207	 bytecodePrimPointY)
	(208 255 sendLiteralSelectorBytecode)
    )
]

SqueakVM pushReceiverVariableBytecode		[ self push: (receiver instVarAt: 1 + (currentBytecode bitAnd: 16rF)) ]
SqueakVM pushTemporaryVariableBytecode		[ self push: (homeContext indexedAt: 1 + (currentBytecode bitAnd: 16rF)) ]
SqueakVM pushLiteralConstantBytecode		[ self push: (method literalAt: 1 + (currentBytecode bitAnd: 16r1F)) ]
SqueakVM pushLiteralVariableBytecode		[ self push: (method literalAt: 1 + (currentBytecode bitAnd: 16r1F)) atValueIndex ]
SqueakVM storeAndPopReceiverVariableBytecode	[ receiver instVarAt: 1 + (currentBytecode bitAnd: 7) put: self stackPop ]
SqueakVM storeAndPopTemporaryVariableBytecode	[ homeContext indexedAt: 1 + (currentBytecode bitAnd: 7) put: self stackPop ]
SqueakVM pushReceiverBytecode			[ self push: receiver ]
SqueakVM pushConstantTrueBytecode		[ self push: trueObj ]
SqueakVM pushConstantFalseBytecode		[ self push: falseObj ]
SqueakVM pushConstantNilBytecode		[ self push: nilObj ]
SqueakVM pushConstantMinusOneBytecode		[ self push: -1 ]
SqueakVM pushConstantZeroBytecode		[ self push:  0 ]
SqueakVM pushConstantOneBytecode		[ self push:  1 ]
SqueakVM pushConstantTwoBytecode		[ self push:  2 ]

SqueakVM returnReceiver				[ self return: receiver      to: homeContext atSenderIndex ]
SqueakVM returnTrue				[ self return: trueObj	     to: homeContext atSenderIndex ]
SqueakVM returnFalse				[ self return: falseObj      to: homeContext atSenderIndex ]
SqueakVM returnNil				[ self return: nilObj        to: homeContext atSenderIndex ]
SqueakVM returnTopFromMethod			[ self return: self stackTop to: homeContext atSenderIndex ]
SqueakVM returnTopFromBlock			[ self return: self stackTop to: activeContext atSenderIndex ]

SqueakVM unknownBytecode			[ self error: 'unknownBytecode' ]

SqueakVM extendedPushBytecode
[
    | descriptor variableType variableIndex |
    descriptor := self fetchByte.
    variableType := (descriptor >> 6) bitAnd: 16r3.
    variableIndex := 1 + (descriptor bitAnd: 16r3F).
    variableType == 0 ifTrue: [^self push: (receiver instVarAt: variableIndex)].
    variableType == 1 ifTrue: [^self push: (homeContext indexedAt: variableIndex)].
    variableType == 2 ifTrue: [^self push: (method literalAt: variableIndex)].
    variableType == 3 ifTrue: [^self push: (method literalAt: variableIndex) atValueIndex].
]

SqueakVM extendedStoreBytecode
[
    | descriptor variableType variableIndex association value |
    descriptor := self fetchByte.
    variableType := (descriptor >> 6) bitAnd: 16r3.
    variableIndex := 1 + (descriptor bitAnd: 16r3F).
    value := self stackTop.
    variableType == 0 ifTrue: [^receiver instVarAt: variableIndex put: value].
    variableType == 1 ifTrue: [^homeContext indexedAt: variableIndex put: value].
    variableType == 2 ifTrue: [^self error: 'illegal store'].
    variableType == 3 ifTrue: [^(method literalAt: variableIndex) atValueIndexPut: value].
]

SqueakVM extendedStoreAndPopBytecode		[ self extendedStoreBytecode; pop ]

SqueakVM singleExtendedSendBytecode
[
    | descriptor |
    descriptor := self fetchByte.
    messageSelector := method literalAt: 1 + (descriptor bitAnd: 16r1F).
    argumentCount := descriptor >> 5.
    self normalSend.
]

SqueakVM doubleExtendedDoAnythingBytecode
[
    | byte2 byte3 opType top |
    byte2 := self fetchByte.
    byte3 := self fetchByte.
    opType := byte2 >> 5.
    opType == 0
	ifTrue:
	   [messageSelector := method literalAt: 1 + byte3.
	    argumentCount := byte2 bitAnd: 16r1F.
	    ^self normalSend].
    opType == 1
	ifTrue:
	   [messageSelector := method literalAt: 1 + byte3.
	    argumentCount := byte2 bitAnd: 16r1F.
	    ^self superclassSend].
    opType == 2 ifTrue: [^self push: receiver instVarAt: 1 + byte3].
    opType == 3 ifTrue: [^self push: method literalAt: 1 + byte3].
    opType == 4 ifTrue: [^self push: (method literalAt: 1 + byte3) atValueIndex].
    opType == 5 ifTrue: [^receiver instVarAt: 1 + byte3 put: self stackTop].
    opType == 6 ifTrue: [^receiver instVarAt: 1 + byte3 put: self stackPop].
    opType == 7 ifTrue: [^(method literalAt: 1 + byte3) atValueIndexPut: self stackTop].
]

SqueakVM singleExtendedSuperBytecode
[
    | descriptor |
    descriptor := self fetchByte.
    messageSelector := method literalAt: 1 + (descriptor bitAnd: 16r1F).
    argumentCount := descriptor >> 5.
    self superclassSend.
]

SqueakVM secondExtendedSendBytecode
[
    | descriptor |
    descriptor := self fetchByte.
    messageSelector := method literalAt: 1 + (descriptor bitAnd: 16r3F).
    argumentCount := descriptor >> 6.
    self normalSend.
]

SqueakVM popStackBytecode			[ stackPointer := stackPointer - 1 ]
SqueakVM duplicateTopBytecode			[ self push: self stackTop ]
SqueakVM pushActiveContextBytecode		[ self push: activeContext ]
SqueakVM experimentalBytecode			[ self error: 'unimplemented: experimentalBytecode' ]

SqueakVM shortUnconditionalJump			[ self jump: 1 + (currentBytecode bitAnd: 7) ]
SqueakVM shortConditionalJump			[ self jumpIfFalseBy: 1 + (currentBytecode bitAnd: 7) ]

SqueakVM longUnconditionalJump
[
    | offset |
    offset := (((currentBytecode bitAnd: 7) - 4) * 256) + self fetchByte.
    instructionPointer := instructionPointer + offset.
    offset < 0 ifTrue: [self quickCheckForInterrupts].
]

SqueakVM longJumpIfTrue				[ self jumpIfTrueBy:  ((currentBytecode bitAnd: 3) * 256) + self fetchByte ]
SqueakVM longJumpIfFalse			[ self jumpIfFalseBy: ((currentBytecode bitAnd: 3) * 256) + self fetchByte ]

SqueakVM bytecodePrimAdd			[ self specialSend:  0 argumentCount: 1 ]
SqueakVM bytecodePrimSubtract			[ self specialSend:  1 argumentCount: 1 ]
SqueakVM bytecodePrimLessThan			[ self specialSend:  2 argumentCount: 1 ]
SqueakVM bytecodePrimGreaterThan		[ self specialSend:  3 argumentCount: 1 ]
SqueakVM bytecodePrimLessOrEqual		[ self specialSend:  4 argumentCount: 1 ]
SqueakVM bytecodePrimGreaterOrEqual		[ self specialSend:  5 argumentCount: 1 ]
SqueakVM bytecodePrimEqual			[ self specialSend:  6 argumentCount: 1 ]
SqueakVM bytecodePrimNotEqual			[ self specialSend:  7 argumentCount: 1 ]
SqueakVM bytecodePrimMultiply			[ self specialSend:  8 argumentCount: 1 ]
SqueakVM bytecodePrimDivide			[ self specialSend:  9 argumentCount: 1 ]
SqueakVM bytecodePrimMod			[ self specialSend: 10 argumentCount: 1 ]
SqueakVM bytecodePrimMakePoint			[ self specialSend: 11 argumentCount: 1 ]
SqueakVM bytecodePrimBitShift			[ self specialSend: 12 argumentCount: 1 ]
SqueakVM bytecodePrimDiv			[ self specialSend: 13 argumentCount: 1 ]
SqueakVM bytecodePrimBitAnd			[ self specialSend: 14 argumentCount: 1 ]
SqueakVM bytecodePrimBitOr			[ self specialSend: 15 argumentCount: 1 ]
SqueakVM bytecodePrimAt				[ self specialSend: 16 argumentCount: 1 ]
SqueakVM bytecodePrimAtPut			[ self specialSend: 17 argumentCount: 2 ]
SqueakVM bytecodePrimSize			[ self specialSend: 18 argumentCount: 0 ]
SqueakVM bytecodePrimNext			[ self specialSend: 19 argumentCount: 0 ]
SqueakVM bytecodePrimNextPut			[ self specialSend: 20 argumentCount: 1 ]
SqueakVM bytecodePrimAtEnd			[ self specialSend: 21 argumentCount: 0 ]
SqueakVM bytecodePrimEquivalent			[ self specialSend: 22 argumentCount: 1 ]
SqueakVM bytecodePrimClass			[ self specialSend: 23 argumentCount: 0 ]
SqueakVM bytecodePrimBlockCopy			[ self specialSend: 24 argumentCount: 1 ]
SqueakVM bytecodePrimValue			[ self specialSend: 25 argumentCount: 0 ]
SqueakVM bytecodePrimValueWithArg		[ self specialSend: 26 argumentCount: 1 ]
SqueakVM bytecodePrimDo				[ self specialSend: 27 argumentCount: 1 ]
SqueakVM bytecodePrimNew			[ self specialSend: 28 argumentCount: 0 ]
SqueakVM bytecodePrimNewWithArg			[ self specialSend: 29 argumentCount: 1 ]
SqueakVM bytecodePrimPointX			[ self specialSend: 30 argumentCount: 0 ]
SqueakVM bytecodePrimPointY			[ self specialSend: 31 argumentCount: 0 ]

SqueakVM sendLiteralSelectorBytecode
[
    "Can use any of the first 16 literals for the selector and pass up to 2 arguments."
    messageSelector := method literalAt: 1 + (currentBytecode bitAnd: 16rF).
    argumentCount := ((currentBytecode >> 4) bitAnd: 3) - 1.
    self normalSend.
]
