{ import: st80 }
{ import: SqueakVM }

{ include "vmProxy.c" }

SqueakVMProxy : Object ( vm )

SqueakVMProxy withVM: squeakVM
[
    self := self new.
    vm := squeakVM.
]

SqueakVMProxy pop: nItems			[ ^vm pop: nItems ]
SqueakVMProxy stackValue: offset		[ ^vm stackValue: offset ]

SqueakVMProxy byteSizeOf: obj			[ ^obj isSmallInteger ifTrue: [0] ifFalse: [obj byteSize] ]

SqueakVMProxy fetchInteger: idx ofObject: obj
[
    | result |
    (obj isSmallInteger not and: [(result := obj instVarAt: 1 + idx) isSmallInteger]) ifFalse: [vm primitiveFail].
    ^result
]

SqueakVMProxy fetchPointer: idx ofObject: obj
[
    obj isSmallInteger ifTrue: [^vm primitiveFailed].
    ^obj instVarAt: 1 + idx
]

SqueakVMProxy firstIndexableField: obj		[ ^obj _elements ]

SqueakVMProxy methodArgumentCount		[ ^vm methodArgumentCount ]

SqueakVMProxy slotSizeOf: obj			[ ^obj isSmallInteger ifTrue: [0] ifFalse: [obj fixedSize + obj indexableSize] ]
SqueakVMProxy isPointers: obj			[ ^obj isSmallInteger not and: [obj isPointers] ]
SqueakVMProxy isWords: obj			[ ^obj isSmallInteger not and: [obj isWords] ]
SqueakVMProxy isWordsOrBytes: obj		[ ^obj isSmallInteger not and: [obj isWordsOrBytes] ]

SqueakVMProxy characterTable			[ ^vm image characterTable ]
SqueakVMProxy displayObject			[ ^vm image displayObject ]
SqueakVMProxy falseObject			[ ^vm image falseObject ]
SqueakVMProxy nilObject				[ ^vm image nilObject ]
SqueakVMProxy trueObject			[ ^vm image trueObject ]

SqueakVMProxy failed				[ ^vm failed ]
SqueakVMProxy primitiveFail			[ ^vm primitiveFail ]

SqueakVMProxy showDisplayBits: aForm l: l t: t r: r b: b	[ ^vm showDisplayBits: aForm left: l top: t right: r bottom: b ]

SqueakVM getProxy
[
    ^self _getProxy: (SqueakVMProxy withVM: self)
]

SqueakVM _getProxy: vmProxy
{
    return getProxy(v_vmProxy);
}
