#if !defined(__surface_imp_h)

# define __surface_imp_h

typedef struct _CWindowDevice	CWindowDevice;
typedef struct _CPixmapDevice	CPixmapDevice;

typedef struct { int type, x, y, key; }		CWindowKeyEvent;
typedef struct { int type, x, y, button; }	CWindowButtonEvent;
typedef struct { int type, x, y; }		CWindowMotionEvent;

typedef union
{
  int			type;
  CWindowKeyEvent	key;
  CWindowButtonEvent	button;
  CWindowMotionEvent	mmotion;
} CWindowEvent;

enum {
  CWindowUnknownEventType= 0,
  CWindowKeyPress,
  CWindowKeyRelease,
  CWindowButtonPress,
  CWindowButtonRelease,
  CWindowMotion
};

typedef struct
{
  int		 width;
  int		 height;
  int		 depth;
  CWindowDevice	*device;
} CWindow;

typedef struct
{
  int		 width;
  int		 height;
  int		 depth;
  void		*bits;
  int		 freeBits;
  CPixmapDevice	*device;
} CPixmap;

extern CWindow	    *newCWindow(int w, int h);
extern void	     deleteCWindow(CWindow *win);
extern CPixmap	    *newCPixmap(CWindow *win, int w, int h, int d, void *bits);
extern void	     deleteCPixmap(CPixmap *pix);
extern void	     blitCWindow(CWindow *win, int dstX, int dstY, CPixmap *src, int srcX, int srcY, int w, int h);
extern CWindowEvent *nextCWindowEvent(CWindow *win, int block);

#endif /* !defined(__surface_imp_h) */
