#define VM_PROXY_MAJOR 1
#define VM_PROXY_MINOR 5

#include "vmProxy.h"

#define _O(I)		((oop)((I) << 1 | 1))
#define _I(O)		((int)(O) >> 1)
#define VM(S, ARGS...)	((int)_send(s_##S, vm, ## ARGS))

static oop vm= 0;

#define MISSING	printf("MISSING: %s:%d %s\n", __FILE__, __LINE__, __PRETTY_FUNCTION__);  exit(1);  return 0

int minorVersion(void)								{ return VM_PROXY_MINOR; }
int majorVersion(void)								{ return VM_PROXY_MAJOR; }
/* InterpreterProxy methodsFor: 'stack access' */
int pop(int nItems)								{ return VM(pop_, _O(nItems)); }
int popthenPush(int nItems, int oop)						{ MISSING; }
int push(int object)								{ MISSING; }
int pushBool(int trueOrFalse)							{ MISSING; }
int pushFloat(double f)								{ MISSING; }
int pushInteger(int integerValue)						{ MISSING; }
double stackFloatValue(int offset)						{ MISSING; }
int stackIntegerValue(int offset)						{ MISSING; }
int stackObjectValue(int offset)						{ MISSING; }

int stackValue(int offset)							{ return (int)VM(stackValue_, _O(offset)); }

/* InterpreterProxy methodsFor: 'object access' */
int argumentCountOf(int methodPointer)						{ MISSING; }
void * arrayValueOf(int oop)							{ MISSING; }
int byteSizeOf(int objectPointer)						{ return _I(VM(byteSizeOf_, objectPointer)); }
void * fetchArrayofObject(int fieldIndex, int objectPointer)			{ MISSING; }
int fetchClassOf(int oop)							{ MISSING; }
double fetchFloatofObject(int fieldIndex, int objectPointer)			{ MISSING; }

int fetchIntegerofObject(int fieldIndex, int objectPointer)			{ return _I(VM(fetchInteger_ofObject_, _O(fieldIndex), objectPointer)); }

int fetchPointerofObject(int fieldIndex, int objectPointer)			{ return VM(fetchPointer_ofObject_, _O(fieldIndex), objectPointer); }

int fetchWordofObject(int fieldFieldIndex, int oop)				{ MISSING; }
void * firstFixedField(int oop)							{ MISSING; }
void * firstIndexableField(int objectPointer)					{ return (void *)VM(firstIndexableField_, objectPointer); }
int literalofMethod(int offset, int methodPointer)				{ MISSING; }
int literalCountOf(int methodPointer)						{ MISSING; }

int methodArgumentCount(void)							{ return _I(VM(methodArgumentCount)); }

int methodPrimitiveIndex(void)							{ MISSING; }
int primitiveIndexOf(int methodPointer)						{ MISSING; }
int sizeOfSTArrayFromCPrimitive(void *cPtr)					{ MISSING; }
int slotSizeOf(int objectPointer)						{ return _I(VM(slotSizeOf_, objectPointer)); }
int stObjectat(int array, int fieldIndex)					{ MISSING; }
int stObjectatput(int array, int fieldIndex, int value)				{ MISSING; }
int stSizeOf(int oop)								{ MISSING; }
int storeIntegerofObjectwithValue(int fieldIndex, int oop, int integer)		{ MISSING; }
int storePointerofObjectwithValue(int fieldIndex, int oop, int valuePointer)	{ MISSING; }
/* InterpreterProxy methodsFor: 'testing' */
int isKindOf(int oop, char *aString)						{ MISSING; }
int isMemberOf(int oop, char *aString)						{ MISSING; }
int isBytes(int oop)								{ MISSING; }
int isFloatObject(int oop)							{ MISSING; }
int isIndexable(int oop)							{ MISSING; }
int isIntegerObject(int objectPointer)						{ MISSING; }
int isIntegerValue(int intValue)						{ MISSING; }
int isPointers(int objectPointer)						{ return VM(isPointers_, objectPointer); }
int isWeak(int oop)								{ MISSING; }
int isWords(int objectPointer)							{ return VM(isWords_, objectPointer); }
int isWordsOrBytes(int objectPointer)						{ return VM(isWordsOrBytes_, objectPointer); }
/* InterpreterProxy methodsFor: 'converting' */
int booleanValueOf(int obj)							{ MISSING; }
int checkedIntegerValueOf(int intOop)						{ MISSING; }
int floatObjectOf(double aFloat)						{ MISSING; }
double floatValueOf(int oop)							{ MISSING; }
int integerObjectOf(int value)							{ MISSING; }
int integerValueOf(int oop)							{ MISSING; }
int positive32BitIntegerFor(int integerValue)					{ MISSING; }
int positive32BitValueOf(int oop)						{ MISSING; }
/* InterpreterProxy methodsFor: 'special objects' */

int characterTable(void)							{ return VM(characterTable); }
int displayObject(void)								{ return VM(displayObject); }
int falseObject(void)								{ return VM(falseObject); }
int nilObject(void)								{ return VM(nilObject); }
int trueObject(void)								{ return VM(trueObject); }


/* InterpreterProxy methodsFor: 'special classes' */
int classArray(void)								{ MISSING; }
int classBitmap(void)								{ MISSING; }
int classByteArray(void)							{ MISSING; }
int classCharacter(void)							{ MISSING; }
int classFloat(void)								{ MISSING; }
int classLargePositiveInteger(void)						{ MISSING; }
int classPoint(void)								{ MISSING; }
int classSemaphore(void)							{ MISSING; }
int classSmallInteger(void)							{ MISSING; }
int classString(void)								{ MISSING; }
/* InterpreterProxy methodsFor: 'instance creation' */
int clone(int oop)								{ MISSING; }
int instantiateClassindexableSize(int classPointer, int size)			{ MISSING; }
int makePointwithxValueyValue(int xValue, int yValue)				{ MISSING; }
int popRemappableOop(void)							{ MISSING; }
int pushRemappableOop(int oop)							{ MISSING; }
/* InterpreterProxy methodsFor: 'other' */
int becomewith(int array1, int array2)						{ MISSING; }
int byteSwapped(int w)								{ MISSING; }

int failed(void)								{ return !!VM(failed); }

int fullDisplayUpdate(void)							{ MISSING; }
int fullGC(void)								{ MISSING; }
int incrementalGC(void)								{ MISSING; }

int primitiveFail(void)								{ return VM(primitiveFail); }

int showDisplayBitsLeftTopRightBottom(int aForm, int l, int t, int r, int b)	{ return VM(showDisplayBits_l_t_r_b_, aForm, _O(l), _O(t), _O(r), _O(b)); }
int signalSemaphoreWithIndex(int semaIndex)					{ MISSING; }
int success(int aBoolean)							{ MISSING; }
int superclassOf(int classPointer)						{ MISSING; }
/* InterpreterProxy methodsFor: 'compiler' */
CompilerHook *compilerHookVector(void)						{ MISSING; }
int setCompilerInitialized(int initFlag)					{ MISSING; }
/* InterpreterProxy methodsFor: 'BitBlt support' */
int loadBitBltFrom(int bbOop)							{ MISSING; }
int copyBits(void)								{ MISSING; }
int copyBitsFromtoat(int leftX, int rightX, int yValue)				{ MISSING; }
/* New for proxy version 1.3 */
int classLargeNegativeInteger(void)						{ MISSING; }
int signed32BitIntegerFor(int integerValue)					{ MISSING; }
int signed32BitValueOf(int oop)							{ MISSING; }
int includesBehaviorThatOf(int aClass, int aSuperClass)				{ MISSING; }
int primitiveMethod (void)							{ MISSING; }
/* InterpreterProxy methodsFor: 'FFI support' */
int classExternalAddress(void)							{ MISSING; }
int classExternalData(void)							{ MISSING; }
int classExternalFunction(void)							{ MISSING; }
int classExternalLibrary(void)							{ MISSING; }
int classExternalStructure(void)						{ MISSING; }

int ioLoadModuleOfLength(int modIndex, int modLength)				{ MISSING; }
int ioLoadSymbolOfLengthFromModule(int fnIndex, int fnLength, int handle)	{ MISSING; }
int isInMemory(int address)							{ MISSING; }
int ioLoadFunctionFrom(char *fnName, char *modName)				{ MISSING; }
int ioMicroMSecs(void)								{ MISSING; }
int positive64BitIntegerFor(squeakInt64 integerValue)				{ MISSING; }
squeakInt64 positive64BitValueOf(int oop)					{ MISSING; }
int signed64BitIntegerFor(squeakInt64 integerValue)				{ MISSING; }
squeakInt64 signed64BitValueOf(int oop)						{ MISSING; }

#undef MISSING

static VirtualMachine vmProxy= {
  minorVersion,
  majorVersion,
  /* InterpreterProxy methodsFor: 'stack access' */
  pop,
  popthenPush,
  push,
  pushBool,
  pushFloat,
  pushInteger,
  stackFloatValue,
  stackIntegerValue,
  stackObjectValue,
  stackValue,
  /* InterpreterProxy methodsFor: 'object access' */
  argumentCountOf,
  arrayValueOf,
  byteSizeOf,
  fetchArrayofObject,
  fetchClassOf,
  fetchFloatofObject,
  fetchIntegerofObject,
  fetchPointerofObject,
  fetchWordofObject,
  firstFixedField,
  firstIndexableField,
  literalofMethod,
  literalCountOf,
  methodArgumentCount,
  methodPrimitiveIndex,
  primitiveIndexOf,
  sizeOfSTArrayFromCPrimitive,
  slotSizeOf,
  stObjectat,
  stObjectatput,
  stSizeOf,
  storeIntegerofObjectwithValue,
  storePointerofObjectwithValue,
  /* InterpreterProxy methodsFor: 'testing' */
  isKindOf,
  isMemberOf,
  isBytes,
  isFloatObject,
  isIndexable,
  isIntegerObject,
  isIntegerValue,
  isPointers,
  isWeak,
  isWords,
  isWordsOrBytes,
  /* InterpreterProxy methodsFor: 'converting' */
  booleanValueOf,
  checkedIntegerValueOf,
  floatObjectOf,
  floatValueOf,
  integerObjectOf,
  integerValueOf,
  positive32BitIntegerFor,
  positive32BitValueOf,
  /* InterpreterProxy methodsFor: 'special objects' */
  characterTable,
  displayObject,
  falseObject,
  nilObject,
  trueObject,
  /* InterpreterProxy methodsFor: 'special classes' */
  classArray,
  classBitmap,
  classByteArray,
  classCharacter,
  classFloat,
  classLargePositiveInteger,
  classPoint,
  classSemaphore,
  classSmallInteger,
  classString,
  /* InterpreterProxy methodsFor: 'instance creation' */
  clone,
  instantiateClassindexableSize,
  makePointwithxValueyValue,
  popRemappableOop,
  pushRemappableOop,
  /* InterpreterProxy methodsFor: 'other' */
  becomewith,
  byteSwapped,
  failed,
  fullDisplayUpdate,
  fullGC,
  incrementalGC,
  primitiveFail,
  showDisplayBitsLeftTopRightBottom,
  signalSemaphoreWithIndex,
  success,
  superclassOf,
  /* InterpreterProxy methodsFor: 'compiler' */
  compilerHookVector,
  setCompilerInitialized,
#if VM_PROXY_MINOR > 1
  /* new for proxy 1.2 */
  /* InterpreterProxy methodsFor: 'BitBlt support' */
  loadBitBltFrom,
  copyBits,
  copyBitsFromtoat,
#endif
#if VM_PROXY_MINOR > 2
  /* New for proxy version 1.3 */
  classLargeNegativeInteger,
  signed32BitIntegerFor,
  signed32BitValueOf,
  includesBehaviorThatOf,
  primitiveMethod,
  /* InterpreterProxy methodsFor: 'FFI support' */
  classExternalAddress,
  classExternalData,
  classExternalFunction,
  classExternalLibrary,
  classExternalStructure,
  ioLoadModuleOfLength,
  ioLoadSymbolOfLengthFromModule,
  isInMemory,
#endif
#if VM_PROXY_MINOR > 3
  /* New for proxy 1.4 */
  ioLoadFunctionFrom,
  ioMicroMSecs,
#endif
#if VM_PROXY_MINOR > 4
  /* New for proxy 1.5 */
  /* This is clearly a sub-optimal way to check for the ability to handle 64 bit
   * long long types but it suffices for the moment
   */
#define squeakInt64 long long
  positive64BitIntegerFor,
  positive64BitValueOf,
  signed64BitIntegerFor,
  signed64BitValueOf
#endif
};

static oop getProxy(oop aVM)
{
  vm= aVM;
  return (oop)&vmProxy;
}
