{ import: Object }

AssemblerLabelTag := [ 0 ]

AssemblerLabel : Object ( tag isDefined _address )

AssemblerLabel new
[
    self := super new.
    tag := (AssemblerLabelTag := AssemblerLabelTag + 1).
    isDefined := false.
    _address := nil.
]

AssemblerLabel isDefined	[ ^isDefined ]
AssemblerLabel _address		[ ^isDefined ifTrue: [_address] ]
AssemblerLabel  address		[ ^SmallInteger value_: _address ]

AssemblerLabel address_: _addr
[
    _address := _addr.
    isDefined := true.
]

AssemblerLabel relocate_: _delta
{
    self->v__address= (oop)((long)(self->v__address) + (long)v__delta);
}

AssemblerLabel printOn: aStream
[
    aStream nextPut: $L; print: tag.
]

"----------------------------------------------------------------"

DynamicAssembler : Object ( _origin listing labels phase )

DynamicAssembler new
[
    self := super new.
    labels := OrderedCollection new.
]

DynamicAssembler define: aLabel
[
    listing nextPutAll: '    '; print: aLabel; nextPut: $:; cr.
    phase == 0
	ifTrue:
	   [aLabel isDefined ifTrue: [self error: 'multiply defined label'].
	    aLabel address_: self _pc.
	    labels add: aLabel]
	ifFalse:
	   [aLabel _address ~~ self _pc ifTrue: [self error: 'phase error']].
]

DynamicAssembler relocateLabels
[
    labels do: [:label |
	listing print: label; space; print: label address base: 16; space.
	label relocate_: self _pc.
	listing print: label address base: 16; cr]
]

DynamicAssembler note: aString			[ listing nextPutAll: '; '; nextPutAll: aString; cr ]
DynamicAssembler note: aString print: anObject	[ listing nextPutAll: '; '; nextPutAll: aString; space; print: anObject; cr ]
