{ import: Object }

Expression : Array ( generic type properties )

Expression type: aType		[  type := aType ]
Expression type			[ ^type ]

Expression properties: props	[  properties := props ]
Expression properties		[ ^properties ]

Expression new
[
    self := super new.
    generic := type := properties := nil.
]

Expression get: propertyName
[
    ^properties notNil ifTrue: [properties at: propertyName ifAbsent: []]
]

Expression put: propertyName value: propertyValue
[
    properties isNil ifTrue: [properties := IdentityDictionary new].
    ^properties at: propertyName put: propertyValue
]

Expression printOn: aStream
[
    type notNil ifTrue: [aStream nextPutAll: type fullSuffix].
    super printContentsOn: aStream.
]

"---- backend attributes ----"

Expression reg: r	[ ^self put: #reg value: r ]
Expression reg		[ ^self get: #reg ]
Expression reg1		[ ^self second get: #reg ]
Expression reg2		[ ^self third  get: #reg ]

Expression off: r	[ ^self put: #off value: r ]
Expression off		[ ^self get: #off ]
Expression off1		[ ^self second get: #off ]
Expression off2		[ ^self third  get: #off ]

Expression arg		[ ^self second ]
Expression arg1		[ ^self second second ]
Expression arg2		[ ^self third  second ]

Expression gen: r	[ ^self put: #gen value: r ]
Expression gen		[ ^self get: #gen ]

Object asExpression		[]
Expression asExpression		[]

Array asExpression
[
    | expr |
    expr := Expression new: self size.
    0 to: self size - 1 do: [:i | expr at: i put: (self at: i) asExpression].
    ^expr
]

Object unquoting: aCollection	[]

Array unquoting: aCollection
[
    | in out |
    in  := ReadStream on: self.
    out := WriteStream on: (Expression new: self size).
    [in atEnd]
	whileFalse:
	   [out nextPut: ((in peek == #':'
			       ifTrue:  [aCollection at: (in next; next)]
			       ifFalse: [in next])
			      unquoting: aCollection)].
    ^out contents
]

Expression unquoting: aCollection
[
    ^(super unquoting: aCollection)
	type:       type;
	properties: properties
]
