Link : Object ( nextLink )

Link nextLink: aLink	[ ^nextLink := aLink ]
Link nextLink		[ ^nextLink ]

ValueLink : Link ( value )

ValueLink with: anObject
[
    self := self new.
    value := anObject.
]

ValueLink printOn: aStream
[
    value printOn: aStream
]

Object asLink
[
    ^ValueLink with: self
]

LinkedList : Collection ( lastLink )

LinkedList new
[
    self := super new.
    lastLink := nil
]

LinkedList addFirst: aLink
[
    lastLink isNil ifTrue: [lastLink := aLink].
    aLink nextLink: lastLink nextLink.
    ^lastLink nextLink: aLink.
]

LinkedList addLast: aLink
[
    ^lastLink := self addFirst: aLink.
]

LinkedList	car	[ ^lastLink nextLink value ]
LinkedList	cdar	[ ^lastLink nextLink nextLink value ]
LinkedList	cddar	[ ^lastLink nextLink nextLink nextLink value ]

LinkedList do: unaryBlock
[
    | link |
    (link := lastLink) isNil ifTrue: [^self].
    [link := link nextLink.
     unaryBlock value: link.
     link ~~ lastLink] whileTrue.
]

[
    | list |
    list := LinkedList new.				StdOut print: list; cr.
    list addLast: 42 asLink.				StdOut print: list; cr.
    list addLast: 666 asLink.				StdOut print: list; cr.
    list addLast: 'done' asLink.			StdOut print: list; cr.
    list := LinkedList new.				StdOut print: list; cr.
    list addFirst: 42 asLink.				StdOut print: list; cr.
    list addFirst: 666 asLink.				StdOut print: list; cr.
    list addFirst: 'done' asLink.			StdOut print: list; cr.
    0 exit.
]

