{ import: Object }
{ import: Assembler }
{ import: BitSet }

{ include "asm-ppc.h" }
{ include "asm-tags.h" }

PowerPC : DynamicAssembler ( clobbers allocators registerSet emptyRegisterSet clobberedSet tempRegs )

"---- assembling ----"

PowerPC _op:op			[ listing "cr; "tab; nextPutAll: op ]
PowerPC _t			[ listing tab ]
PowerPC _r:r			[ listing nextPut: $r; print: r ]
PowerPC _i:i			[ listing print: i ]
PowerPC _d:_d			[ listing print: (SmallInteger value_: _d) base: 16 ]
PowerPC _m:d m:r		[ listing print: d; nextPutAll: '(r'; print: r; nextPutAll: ')' ]
PowerPC _c			[ listing nextPutAll: ', ' ]
PowerPC _n			[ listing "cr; "cr ]

PowerPC _o:op			[ self _op: op;						_n ]
PowerPC _o:op r:rA		[ self _op: op; _t; _r: rA;				_n ]
PowerPC _o:op i:im		[ self _op: op; _t; _i: im;				_n ]
PowerPC _o:op d:_d		[ self _op: op; _t; _d: _d;				_n ]
PowerPC _o:op r:rA r:rB		[ self _op: op; _t; _r: rA; _c; _r: rB;			_n ]
PowerPC _o:op r:rA i:im		[ self _op: op; _t; _r: rA; _c; _i: im;			_n ]
PowerPC _o:op r:rD r:rA i:im	[ self _op: op; _t; _r: rD; _c; _r: rA; _c; _i: im;	_n ]
PowerPC _o:op r:rD r:rA r:rB	[ self _op: op; _t; _r: rD; _c; _r: rA; _c; _r: rB;	_n ]
PowerPC _o:op r:rA m:dd m:rS	[ self _op: op; _t; _r: rA; _c; _m: dd       m: rS;	_n ]

" intrinsic instructions "

PowerPC lis	:rD :im		[ self _o:'lis'   r:rD i:im.		{ LISri	  (_untag(rD), _untag(im)      	     ); } ]
PowerPC li	:rD :im		[ self _o:'li'    r:rD i:im.		{ LIri 	  (_untag(rD), _untag(im)      	     ); } ]
PowerPC add	:rD :rA :rB	[ self _o:'add'   r:rD r:rA r:rB.	{ ADDrrr  (_untag(rD), _untag(rA), _untag(rB)); } ]
PowerPC addi	:rD :rS :im	[ self _o:'addi'  r:rD r:rS i:im.	{ ADDIrri (_untag(rD), _untag(rS), _untag(im)); } ]
PowerPC mullw	:rD :rA :rB	[ self _o:'mullw' r:rD r:rA r:rB.	{ MULLWrrr(_untag(rD), _untag(rA), _untag(rB)); } ]
PowerPC or_	:rD :rA :rB	[ self _o:'or.'   r:rD r:rA r:rB.	{ OR_rrr  (_untag(rD), _untag(rA), _untag(rB)); } ]
PowerPC ori	:rD :rS :im	[ self _o:'ori'   r:rD r:rS i:im.	{ ORIrri  (_untag(rD), _untag(rS), _untag(im)); } ]
PowerPC lwz	:rD :dd :rS	[ self _o:'lwz'   r:rD m:dd m:rS.	{ LWZrm	  (_untag(rD), _untag(dd), _untag(rS)); } ]
PowerPC stw	:rS :dd :rD	[ self _o:'stw'   r:rS m:dd m:rD.	{ STWrm	  (_untag(rS), _untag(dd), _untag(rD)); } ]
PowerPC stwu	:rS :dd :rD	[ self _o:'stwu'  r:rS m:dd m:rD.	{ STWUrm  (_untag(rS), _untag(dd), _untag(rD)); } ]
PowerPC mflr	:rD		[ self _o:'mflr'  r:rD.			{ MFLRr	  (_untag(rD)			     ); } ]
PowerPC mtlr	:rS		[ self _o:'mtlr'  r:rS.			{ MTLRr	  (_untag(rS)			     ); } ]
PowerPC mtctr	:rS		[ self _o:'mtctr' r:rS.			{ MTCTRr  (_untag(rS)			     ); } ]
PowerPC blr			[ self _o:'blr'.			{ BLR	  (		      	      	     ); } ]
PowerPC bctrl			[ self _o:'bctrl'.			{ BCTRL	  (		      	      	     ); } ]
PowerPC b	:_d		[ self _o:'b'     d:_d.			{ Bi	  ((long)v__d	      	      	     ); } ]
PowerPC beq	:_d		[ self _o:'beq'   d:_d.			{ BEQi	  ((long)v__d	      	      	     ); } ]
PowerPC bne	:_d		[ self _o:'bne'   d:_d.			{ BNEi	  ((long)v__d	      	      	     ); } ]

" synthetic instructions "

PowerPC mr	:rD :rS
[
    rD ~~ rS ifTrue:		[ self _o:'mr'	 r:rD r:rS.		{ MRrr	 (_untag(rD), _untag(rS)	    ); } ]
]

" flush insn cache and run "

PowerPC execute
{
    iflush((insn *)self->v__origin, asm_pc);
    return ((void *(*)(void))self->v__origin)();
}

"---- code generation ----"

SmallInteger hi		[ ^self >> 16 ]
SmallInteger lo		[ ^self bitAnd: 0xffff ]

ArrayedCollection hi		[ ^SmallInteger value_: (self _hi_: self _elements) ]
ArrayedCollection lo		[ ^SmallInteger value_: (self _lo_: self _elements) ]
ArrayedCollection _hi_: _ptr	{ return (oop)((unsigned long)v__ptr >> 16); }
ArrayedCollection _lo_: _ptr	{ return (oop)((unsigned long)v__ptr & 0xffff); }

Symbol hi		[ ^SmallInteger value_: (self _hi_: self _dlsym) ]
Symbol lo		[ ^SmallInteger value_: (self _lo_: self _dlsym) ]
Symbol _hi_: _ptr	{ return (oop)((unsigned long)v__ptr >> 16); }
Symbol _lo_: _ptr	{ return (oop)((unsigned long)v__ptr & 0xffff); }

Symbol _dlsym
{
    void *addr= dlsym(RTLD_DEFAULT, (char *)(self->v__elements));
    if (!addr) fprintf(stderr, "%s: %s\n", (char *)(self->v__elements), dlerror());
    return (oop)addr;
}

{ import: ReductionGrammar }

ReductionGrammar forPowerPC
[
    (self := self new)
	"-- baseline --"
	at: #stmt add: #reg			"discard";
	at: #stmt add: #(labelv)		do: [:x | x gen: [:o :_|_ define:o second			]];
	at: #stmt add: #(jumpv)			do: [:x | x gen: [:o :_|_ b	:o second _address		]];
	at: #stmt add: #(jumpnv reg)		do: [:x | x gen: [:o :_|_ or_	:o reg1	:o reg1	:o reg1 ;
									  bne	:o third  _address		]];
	at: #stmt add: #(jumpev reg)		do: [:x | x gen: [:o :_|_ or_	:o reg1	:o reg1	:o reg1 ;
									  beq	:o third  _address		]];
	at: #stmt add: #(reti4	reg)		do: [:x | x gen: [:o :_|_ mr	:3	:o reg1;
									  blr					]];
	at: #stmt add: #(retp4	reg)		do: [:x | x gen: [:o :_|_ mr	:3	:o reg1;
									  blr					]];
	at: #reg  add: #(vregp)			do: [:x | x reg: x arg						 ];
	at: #reg  add: #(cnsti4)		do: [:x | x gen: [:o :_|_ lis	:o reg	:o arg hi ;
									  ori	:o reg	:o reg	:o arg lo	]];
	at: #reg  add: #(cnstp4)		do: [:x | x gen: [:o :_|_ lis	:o reg	:o arg hi ;
									  ori	:o reg	:o reg	:o arg lo	]];
	at: #reg  add: #(addrgp4)		do: [:x | x gen: [:o :_|_ lis	:o reg	:o arg hi ;
									  ori	:o reg	:o reg	:o arg lo	]];
	at: #reg  add: #(indir4 reg)		do: [:x | x gen: [:o :_|_ lwz	:o reg	:0	:o reg1		]];
	at: #reg  add: #(asgni4 reg reg)	do: [:x | x gen: [:o :_|_ stw	:o reg1 :0	:o reg2		]];
	at: #reg  add: #(addi4	reg reg)	do: [:x | x gen: [:o :_|_ add	:o reg	:o reg1 :o reg2		]];
	at: #reg  add: #(subi4	reg reg)	do: [:x | x gen: [:o :_|_ sub	:o reg	:o reg1 :o reg2		]];
	at: #reg  add: #(muli4	reg reg)	do: [:x | x gen: [:o :_|_ mullw :o reg	:o reg1 :o reg2		]];
	at: #reg  add: #(divi4	reg reg)	do: [:x | x gen: [:o :_|_ divw	:o reg	:o reg1 :o reg2		]];
	at: #reg  add: #(modi4	reg reg)	do: [:x | x gen: [:o :_|_ divw	:o reg	:o reg1 :o reg2 ;
									  mullw :o reg	:o reg	:o reg2 ;
									  subf	:o reg	:o reg	:o reg1		]];
	at: #reg  add: #(calli4	reg)		do: [:x | x gen: [:o :_|_ mtctr	:o reg1 ;
									  bctrl					]];
	at: #reg  add: #(argp4 reg)		do: [:x | x reg: x reg1						 ];
	"-- immediate arithmetic --"
""	at: #reg  add: #(addi4	reg (cnsti4))	do: [:x | x gen: [:o :_|_ addi	:o reg	:o reg1 :o arg2		]];
""
	"-- register indexed --"
""	at: #reg  add: #(indir4 mrr)		do: [:x | x gen: [:o :_|_ lwz	:o reg	:o off1 :o reg1		]];
	at: #reg  add: #(asgni4 reg mrr)	do: [:x | x gen: [:o :_|_ stw	:o reg1 :o off2 :o reg2		]];
	at: #mrr  add: #(addi4	reg reg)	do: [:x | x off: x reg1; reg: x reg2				 ];
""
	"-- indexed --"
""	at: #reg  add: #(indir4 mir)		do: [:x | x gen: [:o :_|_ lwz	:o reg	:o off1 :o reg1		]];
	at: #reg  add: #(asgni4 reg mir)	do: [:x | x gen: [:o :_|_ stw	:o reg1 :o off2 :o reg2		]];
	at: #mir  add: #(addi4	reg (cnsti4))	do: [:x | x off: x arg2; reg: x reg1				 ];
	at: #mir  add: #(addi4	(cnsti4) reg)	do: [:x | x off: x arg1; reg: x reg2				 ];
	at: #mir  add: #reg			do: [:x | x off: 0						 ];
""
	yourself.
]

"---- initialize-release ----"

PowerPC new
[
    self := super new.
    _origin := self _balloc: 1024.
    listing := "SinkStream"StdOut.
    clobbers := FastIdentityDictionary new
	at: #calli4 put: #clobber:call:;
	at: #calli8 put: #clobber:call:;
	at: #callp4 put: #clobber:call:;
	at: #callp8 put: #clobber:call:;
	yourself.
    allocators := FastIdentityDictionary new
	at: #calli4 put: #allocate:call:;
	at: #calli8 put: #allocate:call:;
	at: #callp4 put: #allocate:call:;
	at: #callp8 put: #allocate:call:;
	yourself.
    registerSet := self newRegisterSet
	set:  2 through: 10;		"gprs"
	set: 13 through: 31;		"gprs"
	set: 32 through: 63.		"fprs"
    clobberedSet := self newRegisterSet
	set:  2 through: 10;		"gprs"
	set: 32 through: 32 + 13.	"fprs"
    emptyRegisterSet := self newRegisterSet.
    tempRegs := self newRegisterSet.
    self phase0.
]

PowerPC _pc
{
    return (oop)asm_pc;
}

PowerPC phase0
[
    phase := 0.
    { asm_pass= 0;  asm_pc= (insn *)0; }.
]

PowerPC phase1
[
    phase := 1.
    { asm_pass= 1;  asm_pc= (insn *)(self->v__origin); }.
    self relocateLabels.
]

PowerPC release
[
]

PowerPC newRegisterSet
[
    ^BitSet new: 64
]

PowerPC fullRegisterSet
[
    ^registerSet
]

"---- compiling ----"

PowerPC oldAllocate: expr	[ self allocate: expr from: 3 ]

PowerPC oldAllocate: expr from: reg
[
    listing print: reg; nextPutAll: ' <- '; print: expr; cr.
    expr isArray ifFalse: [^self].
    expr type isVoidType ifFalse: [expr reg: reg].
    expr first == #par
	ifTrue:  [1 to: expr size - 1 do: [:i | self allocate: (expr at: i) from: reg        ]]
	ifFalse: [1 to: expr size - 1 do: [:i | self allocate: (expr at: i) from: reg + i - 1]].
]

PowerPC generate: expr
[
    | prog |
    prog := OrderedCollection new.
    self linearise: expr on: prog.
    prog do: [:e | listing tab; print: e; cr].
    self
	phase0; emit: prog;
	phase1; emit: prog.
]


PowerPC emit: prog
[
    listing nextPutAll: '---------------- PHASE '; print: phase; cr.
    prog do: [:insn | listing print: (SmallInteger value_: self _pc) base: 16; nextPutAll: '\t\t\t\t'.
		      self printInsn: insn.
		      listing cr.
		      insn gen value: insn value: self]
]

PowerPC printInsn: insn
[
    insn isArray ifFalse: [^listing print: insn].
    listing nextPut: $(; print: insn first.
    insn from: 1 do:  [:e | (e isArray not or: [e gen isNil]) ifTrue: [listing space.  self printInsn: e]].
    listing nextPut: $)
]

PowerPC linearise: expr on: prog
[
    expr isArray ifFalse: [^self].
    expr from: 1 do: [:e | self linearise: e on: prog].
    expr gen notNil ifTrue: [prog addLast: expr]
]

PowerPC oldCompile: expr
[
    | reducer |
    expr := expr asExpression.
    self oldAllocate: expr.
    reducer := ReductionGrammar forPowerPC.
    reducer listing: listing.
    listing print: reducer; cr.
    reducer reduce: expr to: #stmt.
    self generate: expr.
]

PowerPC compile: expr
[
    | reducer |
    expr := expr asExpression.
    reducer := ReductionGrammar forPowerPC.
    reducer listing: listing.
    listing print: reducer; cr.
    reducer reduce: expr to: #stmt.
    self allocate: expr.
    self generate: expr.
]

PowerPC newAllocate: expr
[
    self clobber:  self newRegisterSet  in: expr.
    self allocate: self fullRegisterSet in: expr.
]

PowerPC clobber: regs in: expr
[
    | clobber oldRegs |
    StdOut nextPutAll: 'clobber:   '; print: regs; nextPutAll: ' in:   '; print: expr; cr.
    expr isArray ifFalse: [^regs].
    expr put: #clobberedRegisters value: regs.
    oldRegs := regs.
    (clobber := clobbers at: expr first ifAbsent: []) notNil
	ifTrue:  [^self perform: clobber with: regs with: expr].
    expr from: 1 reverseDo: [:e | regs := self clobber: regs in: e].
    StdOut nextPutAll: 'clobbered: '; print: oldRegs; nextPutAll: ' in:   '; print: expr; cr.
    ^oldRegs
]

PowerPC clobber: regs call: expr
[
    StdOut nextPutAll: 'clobber:   '; print: regs; nextPutAll: ' call: '; print: expr; cr.
    expr from: 1 doWithIndex: [:e :i | regs := self clobber: regs in: e].
    (regs testAll: clobberedSet) ifFalse: [regs := regs copy setAll: clobberedSet].
    StdOut nextPutAll: 'clobbered: '; print: regs; nextPutAll: ' call: '; print: expr; cr.
    ^regs
]

PowerPC allocate: regs in: expr
[
    | reg allocator |
    expr isArray ifFalse: [^regs].
    tempRegs clearAll; setAll: regs.
    tempRegs clearAll: (expr get: #clobberedRegisters).
    reg := tempRegs removeFirst.
    regs clear: reg.
    expr reg: reg.
    (allocator := allocators at: expr first ifAbsent: []) notNil
	ifTrue:  [regs := self perform: allocator with: regs with: expr]
	ifFalse: [expr from: 1 do: [:e | regs := self allocate: regs in: e]].
    StdOut nextPutAll: 'allocated: '; print: reg; nextPutAll: ' in: '; print: expr; cr.
    ^regs.
]

PowerPC allocate: regs call: expr
[
    expr from: 1 reverseDoWithIndex: [:e :i | regs := self allocate: regs in: e].
    ^regs
]

PowerPC evaluate: expr
[
    ^SmallInteger value_: (self compile: expr; execute)
]

"----------------------------------------------------------------"

{ import: CokeExpression }

Expression evaluate
[
    ^PowerPC new evaluate: self
]
