{ import: File }
{ import: String }

Pipe : Object ( readEnd writeEnd )

Pipe readEnd: r		[  readEnd := r ]
Pipe readEnd		[ ^readEnd ]

Pipe writeEnd: w	[  writeEnd := w ]
Pipe writeEnd		[ ^writeEnd ]

Pipe new
[
    | _r _w |
    {
      int fds[2];
      if (!pipe(fds))
	{
	  v__r= (oop)fds[0];
	  v__w= (oop)fds[1];
          printf("pipe %d %d\n", fds[0], fds[1]);
	}
      else perror("pipe");
    }.
    _r == nil ifTrue: [self error: 'cannot create pipe'].
    ^self
	withReadEnd: (File withDescriptor_: _r)
	writeEnd:    (File withDescriptor_: _w).
]

Pipe withReadEnd: r writeEnd: w
[
    self := super new.
    readEnd  := r.
    writeEnd := w.
]

Pipe reversed
[
    ^self crossConnect: Pipe new
]

Pipe crossConnect: aPipe
[
    | end |
    end := writeEnd.
    writeEnd := aPipe writeEnd.
    aPipe writeEnd: end.
    ^aPipe
]

Pipe nextPutAll: byteArray	[ ^writeEnd write: byteArray ]
Pipe write: byteArray		[ ^writeEnd write: byteArray ]

Pipe next: limit
[
    | ba n |
    ba := String new: limit.
    n := readEnd read: ba.
    ^n > 0 ifTrue: [ba copyFrom: 1 to: n]
]

Pipe read: limit		[ ^self next: limit ]

Pipe next			[ ^self next: 1 ]
Pipe read			[ ^self read: 1 ]

Pipe close
[
    readEnd close.
    writeEnd close.
]
